// ------------------------------------------------------------------
// prototype definitions for diagnostic methods
// ------------------------------------------------------------------

  MathExpression.prototype.hexDump   = MathExpression_hexDump;

  cExprNode.prototype.print          = cExprNode_print;
  cExprNode.prototype.printChild     = cExprNode_printChild;

  HexTable.prototype.display         = HexTable_display;

  cTextSubstitute.prototype.display  = cTextSubstitute_display;

  cSymbolDict.prototype.display      = cSymbolDict_display;

  cTemplateDict.prototype.display    = cTemplateDict_display;

  cTemplate.prototype.display        = cTemplate_display;

// --- global variable for use in cExprNode_printChild
  var wNextTreeLevel = 0;
// ------------------------------------------------------------------
// writes a hex dump of the string in its current state to the page
// ------------------------------------------------------------------
function MathExpression_hexDump(wTitle)
{
   var txt = new String(this.txtStr);
   var dLen = 80; // number of chars per line

   var titleNode = document.createElement('h5');
   titleNode.appendChild(document.createTextNode(wTitle));
   this.parent.appendChild(titleNode);

   while ( txt.length > 0)
   {
     var currTxt = txt.substring(0,dLen);
     txt = txt.substring(dLen);

     var paraNode = document.createElement('p');
     var tableNode = document.createElement("table");
     tableNode.setAttribute("border","0");
     var tbodyNode = document.createElement('tbody');

     var row1Node = document.createElement('tr');
     var row2Node = document.createElement('tr');
     var row3Node = document.createElement('tr');
     for (var ix = 0; ix < currTxt.length; ix++)
     {
       var char = currTxt.charAt(ix);
       var posx;
       for (posx = 0; posx < 256 && char != gHexTable.charArr[posx][0]; posx++);


       var eltNode = document.createElement('td');
       eltNode.setAttribute("width","10");
       eltNode.style.fontSize = "75%";
       eltNode.style.textAlign = "center";
       eltNode.appendChild(document.createTextNode(char));
       row1Node.appendChild(eltNode);

       eltNode = document.createElement('td');
       eltNode.style.fontSize = "75%";
       eltNode.style.textAlign = "center";
       if (posx < 256)
         eltNode.appendChild(document.createTextNode(gHexTable.charArr[posx][1]));
       else
         eltNode.appendChild(document.createTextNode("?"));
       row2Node.appendChild(eltNode);

       eltNode = document.createElement('td');
       eltNode.style.fontSize = "75%";
       eltNode.style.textAlign = "center";
       if (posx < 256)
         eltNode.appendChild(document.createTextNode(gHexTable.charArr[posx][2]));
       else
         eltNode.appendChild(document.createTextNode("?"));
       row3Node.appendChild(eltNode);
     }
     tbodyNode.appendChild(row1Node);
     tbodyNode.appendChild(row2Node);
     tbodyNode.appendChild(row3Node);

     tableNode.appendChild(tbodyNode);
     paraNode.appendChild(tableNode);

     this.parent.appendChild(paraNode);
   }
}
// ------------------------------------------------------------------
// print outs the expression node and all it's children
// ------------------------------------------------------------------
function cExprNode_print(DomNode)
{
   var paraNode = document.createElement('p');
//   paraNode.style.margin = "0px";
   var tableNode = document.createElement("table");
   tableNode.setAttribute("border","0");
   tableNode.setAttribute("cellSpacing","10");
   var tbodyNode = document.createElement("tbody");

   this.printChild(tbodyNode);

   tableNode.appendChild(tbodyNode);
   paraNode.appendChild(tableNode);
   DomNode.appendChild(paraNode);
}
// ------------------------------------------------------------------
// print outs the expression node and all it's children
// ------------------------------------------------------------------
function cExprNode_printChild(tbodyNode)
{
   for (var ix = this.children.length - 1; ix >= 0 ; ix--)
      this.children[ix].printChild(tbodyNode);

   var rowNode = document.createElement("tr");
   var eltNode;
   var spacer = "<span style='font-family:symbol'>";
   for (var ix = 0; ix < this.level - 1; ix++)
   {
     if (ix == this.level - 2)
        if (wNextTreeLevel < this.level)
           spacer += "&#43;&#190;&#190;&nbsp;&nbsp;";
        else
           spacer += "&#189;&#190;&#190;&nbsp;&nbsp;";
     else
        spacer += "&#189;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
   }
   spacer += "</span>";
   wNextTreeLevel = this.level;

   eltNode = document.createElement('td');
   eltNode.innerHTML = (this.level);
   rowNode.appendChild(eltNode);


   eltNode = document.createElement('td');
   if (this.nodeType == eqnTypes.PHRASE)
   {
      eltNode.innerHTML = ("phrase");
      rowNode.appendChild(eltNode);
      eltNode = document.createElement('td');
      eltNode.innerHTML = (spacer + "phrase");
   }
   else if (this.nodeType == eqnTypes.TEMPLATE)
   {
      eltNode.innerHTML = ("template: ");
      rowNode.appendChild(eltNode);
      eltNode = document.createElement('td');
      eltNode.innerHTML = (spacer + this.template.name);
   }
   else if (this.nodeType == eqnTypes.FORMAT)
   {
      eltNode.innerHTML = ("formatting: ");
      rowNode.appendChild(eltNode);
      eltNode = document.createElement('td');
      eltNode.innerHTML = (spacer + this.formatDesc);
   }
   else
   {
      eltNode.innerHTML = ("text: ");
      rowNode.appendChild(eltNode);
      eltNode = document.createElement('td');
      eltNode.innerHTML = (spacer + "\"" + this.text + "\"");
   }
   rowNode.appendChild(eltNode);

   eltNode = document.createElement('td');
   if (this.rowCount == 1)
      eltNode.innerHTML = (this.rowCount + " row");
   else
      eltNode.innerHTML = (this.rowCount + " rows");
   rowNode.appendChild(eltNode);

   tbodyNode.insertBefore(rowNode,tbodyNode.childNodes[0]);

}
// ------------------------------------------------------------------
// displays hex table
// ------------------------------------------------------------------
function HexTable_display(DispNode)
{
   for ( var ix = 0; ix < 8; ix++)
   {

     var paraNode = document.createElement('p');
     var tableNode = document.createElement('table');
     var tbodyNode = document.createElement('tbody');
     tableNode.setAttribute("border","1");

     var row1Node = document.createElement('tr');
     var row2Node = document.createElement('tr');
     var row3Node = document.createElement('tr');
     for ( var jx = 0; jx < 32; jx++)
     {
       var posx = ix * 32 + jx;

       eltNode = document.createElement('td');
       eltNode.setAttribute("width","15");
       if (posx < 256)
         eltNode.appendChild(document.createTextNode(this.charArr[posx][0]));
       else
         eltNode.appendChild(document.createTextNode("?"));
       row1Node.appendChild(eltNode);

       eltNode = document.createElement('td');
       if (posx < 256)
         eltNode.appendChild(document.createTextNode(this.charArr[posx][1]));
       else
         eltNode.appendChild(document.createTextNode("?"));
       row2Node.appendChild(eltNode);

       eltNode = document.createElement('td');
       if (posx < 256)
         eltNode.appendChild(document.createTextNode(this.charArr[posx][2]));
       else
         eltNode.appendChild(document.createTextNode("?"));
       row3Node.appendChild(eltNode);
     }
     tbodyNode.appendChild(row1Node);
     tbodyNode.appendChild(row2Node);
     tbodyNode.appendChild(row3Node);

     tableNode.appendChild(tbodyNode);
     paraNode.appendChild(tableNode);
     DispNode.appendChild(paraNode);
   }
}
// ------------------------------------------------------------------
// displays symbol substitution table
// ------------------------------------------------------------------
function cTextSubstitute_display(DispNode)
// ********* this funct. needs to be converted to DOM
{
   var tableNode = document.createElement('table');
   var tbodyNode = document.createElement('tbody');
   tableNode.setAttribute("border","1");
   tableNode.style.borderColor = "blue";
   tableNode.style.borderStyle = "solid";

   var thNode, rowNode, eltNode;

   var spaceSymb = new String("<span style=\"font-family:symbol;color:cyan\">&#183;</span>");
//   tableNode.innerHTML = "<th>Original<br/>HTML</th><th>Subtituted by<br/>Mathyma</th> <th>Appears on<br/>Page</th>";
   rowNode = document.createElement('tr');
   thNode = document.createElement('th');
   thNode.style.borderColor = "#bbf";
   thNode.style.borderStyle = "solid";
   thNode.innerHTML = "Original<br/>Source";
   rowNode.appendChild(thNode);
   thNode = document.createElement('th');
   thNode.style.borderColor = "#bbf";
   thNode.style.borderStyle = "solid";
   thNode.innerHTML = "Subtituted by<br/>Mathyma";
   rowNode.appendChild(thNode);
   thNode = document.createElement('th');
   thNode.style.borderColor = "#bbf";
   thNode.style.borderStyle = "solid";
   thNode.innerHTML = "Appears on<br/>Page";
   rowNode.appendChild(thNode);
   tbodyNode.appendChild(rowNode);

   eltNode = document.createElement('td');
   eltNode.style.borderColor = "blue";
   eltNode.style.borderStyle = "solid";
   eltNode.setAttribute("colSpan","3");
   eltNode.setAttribute("align","center");
   eltNode.innerHTML = "the symbol " + spaceSymb + " represents a space";
   rowNode = document.createElement('tr');
   rowNode.appendChild(eltNode);
   tbodyNode.appendChild(rowNode);
   for ( var tabIx = 0; tabIx < this.elemTab.length; tabIx++)
   {
      var inSymb = this.elemTab[tabIx][0];
      var outSymb = this.elemTab[tabIx][1];
      var printSymb = this.elemTab[tabIx][0];
      var ix;

      inSymb = zSubstit(inSymb,"<","&lt;");
      inSymb = zSubstit(inSymb,">","&gt;");
      inSymb = zSubstit(inSymb," ",spaceSymb);

      outSymb = zSubstit(outSymb,"&","&amp;");
      outSymb = zSubstit(outSymb,"<","&lt;");
      outSymb = zSubstit(outSymb,">","&gt;");
      outSymb = zSubstit(outSymb," ",spaceSymb);

      if (printSymb == "{-") printSymb = "{-}"; //otherwise non-matching brackets error

      rowNode = document.createElement('tr');

      eltNode = document.createElement('td');
      eltNode.style.borderColor = "#bbf";
      eltNode.style.borderStyle = "solid";
      eltNode.innerHTML = inSymb;
      rowNode.appendChild(eltNode);

      eltNode = document.createElement('td');
      eltNode.style.borderColor = "#bbf";
      eltNode.style.borderStyle = "solid";
      eltNode.innerHTML = outSymb;
      rowNode.appendChild(eltNode);

      eltNode = document.createElement('td');
      eltNode.style.borderColor = "#bbf";
      eltNode.style.borderStyle = "solid";
      var spanNode = document.createElement('span');
      var wExpr = new MathExpression (spanNode,printSymb)
      eltNode.appendChild(spanNode);
      rowNode.appendChild(eltNode);

      tbodyNode.appendChild(rowNode);
   }

   tableNode.appendChild(tbodyNode);
   DispNode.appendChild(tableNode);

// "internal" func.
   function zSubstit(inString,fromGlyph,toGlyph)
   {
      var wStr = inString;
      var ix = wStr.indexOf(fromGlyph);
      while (ix > -1)
      {
         if (ix == 0)
            wStr = toGlyph + wStr.substr(ix+1);
         else
            wStr = wStr.substr(0,ix) + toGlyph + wStr.substr(ix+1);
         ix = wStr.indexOf(fromGlyph, ix + toGlyph.length);
      }

      return wStr;
   }
}
// --------------------------------------------------------------------
// cSymbolDict method prints all the symbols in the dictionary
// --------------------------------------------------------------------
function cSymbolDict_display(DispNode)
{
   var paraNode = document.createElement('p');
   var tableNode = document.createElement('table');
   tableNode.style.borderColor = "blue";
   tableNode.style.borderStyle = "solid";
   var tbodyNode = document.createElement('tbody');
   var rowNode, eltNode;
   tableNode.setAttribute("border","1");
   paraNode.innerHTML = "<br><b>Dictionary has "
     + this.member.length + " Symbols:</b>";
   var jx = 0;
   for (var ix = 0; ix < this.member.length; ix++)
   {
      if (jx == 0)
      {
         if (ix > 0)
            tbodyNode.appendChild(rowNode);
         rowNode = document.createElement('tr');
      }
      eltNode = document.createElement('td');
      eltNode.style.borderColor = "#bbf";
      eltNode.style.borderStyle = "solid";
      eltNode.innerHTML = this.member[ix].abbr ;
      rowNode.appendChild(eltNode);
      eltNode = document.createElement('td');
      eltNode.style.borderColor = "#bbf";
      eltNode.style.borderStyle = "solid";
      eltNode.appendChild(this.getSymbol(ix))
      /*
      if (this.member[ix].font == "S")
         eltNode.style.fontFamily = "symbol";
      else if (this.member[ix].font == "A")
         eltNode. style.fontFamily = "sans-serif";
      eltNode.innerHTML = "&#" + this.member[ix].symb ;
      */
      rowNode.appendChild(eltNode);
      if (jx != 3)
      {
         eltNode = document.createElement('td');
         eltNode.style.borderColor = "#bbf";
         eltNode.style.borderStyle = "solid";
         eltNode.setAttribute("width","13px");
         eltNode.innerHTML = " " ;
         rowNode.appendChild(eltNode);
      }
      jx++;
      if (jx == 4)
         jx = 0;
   }
   tbodyNode.appendChild(rowNode);
   tableNode.appendChild(tbodyNode);
   paraNode.appendChild(tableNode);
   DispNode.appendChild(paraNode);
}
// --------------------------------------------------------------------
// cTemplateDict method prints all the templates in the dictionary
// --------------------------------------------------------------------
function cTemplateDict_display(iType, DispNode)
{
  // iType: L-list without elt details, P-print with element details
  var ix;
  var paraNode = document.createElement('p');
  paraNode.innerHTML =("<b>Dictionary has "+ this.member.length + " templates:</b>");
  DispNode.appendChild(paraNode);
  for (ix = 0; ix < this.member.length; ix++)
  {
     if (this.member[ix].name.charAt(0) != "_")
        this.member[ix].display(iType, DispNode);
  }
  this.displayed = true;
}
// --------------------------------------------------------------------
// cTemplate method prints details of the templates
// --------------------------------------------------------------------
function cTemplate_display(iType, DispNode)
{
   var parmStr = new String ("abcdefghijklmnop")
   var paraNode = document.createElement('p');
   var wTxt = " "
     + "<b> " + this.name + "</b>"
     + " [" + this.rows + " &#215; "
     + " " + this.cols + "] "
     + " " + this.desc;
   paraNode.innerHTML = wTxt;
   DispNode.appendChild(paraNode);
   if (iType == "D")
   {
      paraNode = document.createElement('p');
      var tableNode = document.createElement('table');
      tableNode.setAttribute("width","80%");
      tableNode.setAttribute("border","1");
      var tbodyNode = document.createElement('tbody');
      var rowNode = document.createElement('tr');
      var eltNode;

      var wExpr = new String();
      wExpr =  this.name + "{";
      for ( var ix = 0; ix < this.parms; ix++)
      {
        if (ix > 0)
          wExpr += ",";
        wExpr += "" + parmStr.charAt(ix);
      }
      wExpr += "}";

      eltNode = document.createElement('td');
      eltNode.innerHTML = wExpr;
      eltNode.setAttribute("width","40%");
      rowNode.appendChild(eltNode);

      eltNode = document.createElement('td');
      if(this.name != "matrix" && this.name != "det" && this.name != "array")
      {
         eltNode.innerHTML = wExpr;
         translateNode(eltNode);
      }
      else
         eltNode.innerHTML = "See below";
      rowNode.appendChild(eltNode);

      tbodyNode.appendChild(rowNode);
      tableNode.appendChild(tbodyNode);
      paraNode.appendChild(tableNode);
      DispNode.appendChild(paraNode);
   }
}


