// ******************************************************************
// * Mathyma version 3 by Arfon Parry
// ******************************************************************
// * Log of changes
// * V3.01 October 2007 -
// *       Development version: Instead of being triggered by a
// *       number of JavaScript calls, mathyma now analyzes the
// *       document object model (DOM) for specified divisions
// *       (class=mathyma) and translates the mathematical text by
// *       augmenting the DOM (instead of document.write).
// *
// ******************************************************************


   var gBrowserName = window.navigator.appName;

   var hexString =
     "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0A\x0B\x0C\x0D\x0E\x0F" +
     "\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F" +
     "\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2A\x2B\x2C\x2D\x2E\x2F" +
     "\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3A\x3B\x3C\x3D\x3E\x3F" +
     "\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\x4A\x4B\x4C\x4D\x4E\x4F" +
     "\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\x5A\x5B\x5C\x5D\x5E\x5F" +
     "\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\x6A\x6B\x6C\x6D\x6E\x6F" +
     "\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\x7A\x7B\x7C\x7D\x7E\x7F" +
     "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F" +
     "\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F" +
     "\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF" +
     "\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF" +
     "\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF" +
     "\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF" +
     "\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF" +
     "\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF" ;

   var bTraceFlag = false; // switched on by processes for debugging
   var wMathymaLib = getRelDir();
   if (!window.Node) {
      var Node = {            // If there is no Node object, define one
         ELEMENT_NODE: 1,    // with the following properties and values.
         ATTRIBUTE_NODE: 2,  // Note that these are HTML node types only.
         TEXT_NODE: 3,       // For XML-specific nodes, you need to add
         COMMENT_NODE: 8,    // other constants here.
         DOCUMENT_NODE: 9,
         DOCUMENT_FRAGMENT_NODE: 11
      }
   }

   // global variables

   var gSpanCount = 1;

   var diagnostics =
   {
      TEXT  : 0x0001, // show text manipulation
      PARSE : 0x0004, // show expression parsing
      GRID  : 0x0008, // show all grids
      SUMA  : 0x0010, // summary of each call
      FULL  : 0xFFFF
   }

   // non-typable special characters
   var mathSymbol =
   {
      OPEN_DELIMITER      : "\xEF",
      TEMPLATE_OPEN       : "\xED",
      FORMAT_OPEN         : "\xEC",
      MULTI_OPEN          : "\xEB",
      TEMP_SLASH          : "\xEA",
      TEMP_OPEN           : "\xE9",
      TEMP_CLOSE          : "\xE8",
      CLOSE_DELIMITER     : "}",

      SUPERSCRIPT         : "^",
      SUBSCRIPT           : "_",
      BOLD_STYLE          : "#",
      ITALIC_STYLE        : "~",
      CURSIVE_STYLE       : "@",
      OVERWRITE           : "$"
   }

   var wScriptString = ""
    + mathSymbol.SUPERSCRIPT
    + mathSymbol.SUBSCRIPT
    + mathSymbol.BOLD_STYLE
    + mathSymbol.ITALIC_STYLE
    + mathSymbol.CURSIVE_STYLE
    + mathSymbol.OVERWRITE     ;

   var eqnTypes =
   {
      PHRASE              : 1,
      TEMPLATE            : 2,
      FORMAT              : 3,
      TEXT                : 4,
      EQUATION            : 5
   }

// ------------------------------------------------------------------
// global conversion tables (only built once for the document)
// ------------------------------------------------------------------
   var gTextSubstitute = new cTextSubstitute ();
   var gHexTable = new HexTable ();
   var gTemplateDict = new cTemplateDict ();

   var gMySys = new cMathymaSystem();

// ------------------------------------------------------------------
// prototype for string method
// ------------------------------------------------------------------
   String.prototype.replace = String_replace
// ------------------------------------------------------------------

   var debug = false;

// ====================================================================
//  Class: cMathymaSystem.
//    This "static" object will contain all the "global" variables
//    necessary to controll the equation printing.
// ====================================================================
function cMathymaSystem () // ---------- class definition -----------
{
  this.margin = 0;
  this.errorCode = 0;
  this.diagnosticLevel = 0;

  // methods
  this.setDiagnostics   = cMathymaSystem_setDiagnostics;
  this.setMargin = cMathymaSystem_setMargin;
}

// --------------------------------------------------------------------
// cMathymaSystem method to set the level of diagnostics
// --------------------------------------------------------------------
function cMathymaSystem_setDiagnostics (iString)
{
  var wStr = iString.toUpperCase();
  var wDiagnMessage = "";

  if (wStr.indexOf("TEXT") > -1)
  {
    this.diagnosticLevel |= diagnostics.TEXT;
    wDiagnMessage += "Display Input, "
  }
  if (wStr.indexOf("PARSE") > -1)
  {
    this.diagnosticLevel |= diagnostics.PARSE;
    wDiagnMessage += "Parsing, "
  }
  if (wStr.indexOf("GRID") > -1)
  {
    this.diagnosticLevel |= diagnostics.GRID;
    wDiagnMessage += "Table Grid, "
  }
  if (wStr.indexOf("SUMA") > -1)
  {
    this.diagnosticLevel |= diagnostics.SUMA;
    wDiagnMessage += "Summary, "
  }
  if (wStr.indexOf("FULL") > -1)
  {
    this.diagnosticLevel |= diagnostics.FULL;
    wDiagnMessage = "Full Diagnostics "
  }

  if (wStr.indexOf("OFF") > -1)
  {
    this.diagnosticLevel = 0;
  }

  if (this.diagnosticLevel > 0)
  {
    document.write("<br><br><b> Diagnostics level = "
      + this.diagnosticLevel + ": </b>" + wDiagnMessage + "<br /><br />");
  }
  else if (wStr.indexOf("OFF") > -1)
  {
    document.write("<br><br><b> Diagnostics OFF </b>");
  }
}
// --------------------------------------------------------------------
// cMathymaSystem method to set the margin
// --------------------------------------------------------------------
function cMathymaSystem_setMargin (iString)
{
    this.margin = iString;
}
// ------------------------------------------------------------------
// Starts off the recursive translation at the top <body> node
// ------------------------------------------------------------------
function translateDoc()
{
   // alert ("translateDoc");
   var wDivNodes = document.getElementsByTagName('div');

   var wMathDivs = new Array();
   // create "deep" copy of math nodes which is unaffected by lower manipulations
   for (var ix = 0; ix < wDivNodes.length; ix++)
   if (wDivNodes[ix].className.toUpperCase() == "MATHYMA")
      wMathDivs[wMathDivs.length] = wDivNodes[ix];

   for (var ix = 0; ix < wMathDivs.length; ix++)
      translateNode(wMathDivs[ix]);

   var mathymaLinkNode   = document.getElementById("mathymaLink");
   if (mathymaLinkNode)
   {
      var pNode = mathymaLinkNode.appendChild(document.createElement("span"));
      pNode.appendChild(document.createTextNode("These notes were created with the "));
      var aNode = pNode.appendChild(document.createElement("a"));
      aNode.setAttribute("href","http://www.mathyma.com/index.html");
      aNode.appendChild(document.createTextNode("Mathyma"));
      pNode.appendChild(document.createTextNode("  package of free software."));
   }

   var mathymaPrintNode   = document.getElementById("mathymaPrint");
   if (mathymaPrintNode)
//     mathymaPrintNode.insertAdjacentHTML("BeforeEnd",
//     "<form id=\"MWComp\"><input type=\"button\" value=\"printable version\" onclick=\"zCompileDoc()\"></form>");
   {
      var xNode = document.createElement("input");
      xNode.setAttribute("type","button");
      xNode.setAttribute("value","printable version");
      addNavListener(xNode,"click",zCompileDoc);
      mathymaPrintNode.appendChild(xNode);
   }

   DispNode   = document.getElementById("mathymaHexTable");
   if (DispNode)
      gHexTable.display(DispNode);

   DispNode   = document.getElementById("mathymaTextSubs");
   if (DispNode)
      gTextSubstitute.display(DispNode);

   DispNode   = document.getElementById("mathymaSymbols");
   if (DispNode)
      gSymbolDict.display(DispNode);

   DispNode   = document.getElementById("mathymaTemplates");
   if (DispNode)
      gTemplateDict.display("D", DispNode);

   var mathymaMailNode   = document.getElementById("mathymaMail");
   if (mathymaMailNode)
//     mathymaMailNode.insertAdjacentHTML("BeforeEnd",
//      "<a" + " title=\"" + "em" + "ail Mathyma" + "\" href=\"" + myRef + "\">em" + "ail</a> ");
   {
      var myRef = "mai" + "lto:admi" + "nistrator@ma" +
         "thyma.c" + "om";
      var xNode = mathymaMailNode;
      xNode = xNode.appendChild(document.createElement("a"));
      xNode.setAttribute("href",myRef);
      xNode.setAttribute("title","em" + "ail Mathyma");
      xNode.appendChild(document.createTextNode("em" + "ail "));
   }

}
// ------------------------------------------------------------------
// translate an individual DOM element (node) [part of recursion]
// ------------------------------------------------------------------
function translateNode(wNode)
{
   if (wNode.nodeType == Node.TEXT_NODE)
   {
     translateText(wNode);
   }
   else
   {
      var wChildren = new Array();
      // create "deep" copy of child array which is unaffected by lower manipulations
      for(var cix=0; cix < wNode.childNodes.length; cix++)
         wChildren[cix] = wNode.childNodes[cix];
      for(var cix=0; cix < wChildren.length; cix++)
         translateNode(wChildren[cix]);
   }
}
// ------------------------------------------------------------------
// translate a text element according to Mathyma syntaxt
// ------------------------------------------------------------------
function translateText(wNode)
{
   wParent = wNode.parentNode;
   var spanNode  = document.createElement('span');
   wParent.replaceChild(spanNode,wNode);
   var wExpr = new MathExpression (spanNode, wNode.nodeValue)
}
// ------------------------------------------------------------------
// translate a text element according to Mathyma syntaxt
// ------------------------------------------------------------------
function zMath(wText)
{
   var wSpanId = "Mathyma" + gSpanCount++;
   document.write("<span id=\"" + wSpanId + "\"></span>");
   var spanNode  = document.getElementById(wSpanId);
   var wExpr = new MathExpression (spanNode, wText)
}
// === Class: MathExpression =============================================
// This class translates the character string taken from the HTML
// and writes 'formatted' expressions to the DOM
// ------------------------------------------------------------------
function MathExpression // ------------- class definition -----------
   (inParent, inString)
{
  // attributes
  this.parent = inParent;
  this.txtStr = new String(inString);
  this.errorCode = 0;
  this.charArr = new Array (256);
  this.eqnTree;
  this.maxNest = 0;

  // methods
//  this.hexDump                       = MathExpression_hexDump;   //external
  this.evalString                    = MathExpression_evalString;
  this.textSubstitute                    = MathExpression_textSubstitute;
  this.addFormatDelims               = MathExpression_addFormatDelims;
  this.insertTemplAbbrev             = MathExpression_insertTemplAbbrev;
  this.matchBrackets                 = MathExpression_matchBrackets;
  this.matchSeparators               = MathExpression_matchSeparators;
  this.expandMatrix                  = MathExpression_expandMatrix;
  this.manipulateArray               = MathExpression_manipulateArray;

  if (gMySys.diagnosticLevel == diagnostics.SUMA)
     alert (this.txtStr.substr(0,20));

  // constructor
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("original");

  // --- evaluate JS expressions
  this.evalString();
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("evalString");

  // --- do symbol substitution
  this.textSubstitute();
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("textSubstitute");

  // --- match brackets
  this.matchBrackets(true);
  if (this.errorCode > 0)
  { alert ("matchBrackets error: " + this.errorCode + "\n" + this.txtStr.substr(0,80)); return;}
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("matchBrackets");

  // --- insert delimiters for formatting
  this.addFormatDelims();
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("addFormatDelims");

  // --- translate template names
  this.insertTemplAbbrev();
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("insertTemplAbbrev");

  // --- matrix and determinant expansion
  this.expandMatrix();
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("expandMatrix");

  // --- match parameter separating slashes (arrays)
  this.matchSeparators(mathSymbol.TEMP_SLASH);
  if (this.errorCode > 0)
  { alert ("matchSeparators error: " + this.errorCode); return;}
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("matchSeparators(/)");

  // --- match parameter separating commas
  this.matchSeparators(",");
  if (this.errorCode > 0)
  { alert ("matchSeparators error: " + this.errorCode); return;}
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("matchSeparators(,)");

  // --- replaces array template with dimensioned latice
  this.manipulateArray();
  if (gMySys.diagnosticLevel & diagnostics.TEXT)
     this.hexDump("manipulateArray");

  // --- parse the string into an expression "tree"
  this.eqnTree = new cExprNode (this, this.txtStr, 0);

  // --- enumerate rows in order to repeat vertical symbols correctly
  this.eqnTree.countRows();
  if (gMySys.diagnosticLevel & diagnostics.PARSE)
     this.eqnTree.print(this.parent);

  // --- translate the expression tree into HTML and append to document
  //alert("translating");
  this.parent.appendChild(this.eqnTree.translate());
  /**/

}
// ------------------------------------------------------------------
// evaluates any javascipt string variables
// ------------------------------------------------------------------
function MathExpression_evalString()
{
   var Str = new String (this.txtStr);
   var pIx = Str.indexOf ("zEval{");
   while (pIx > -1)
   {
      sIx = Str.indexOf ("{",pIx);
      eIx = Str.indexOf ("}",sIx);
      var wPhrase = Str.substr(sIx + 1,eIx - sIx - 1);
      var wSubs = eval(wPhrase);
      Str = Str.substr(0,pIx) + wSubs + Str.substr(eIx+1);
      pIx = Str.indexOf ("zEval{");
   }
   this.txtStr = Str;
}
// ------------------------------------------------------------------
// performs symbol substitution in string
// ------------------------------------------------------------------
function MathExpression_textSubstitute()
{
   // note: browser strips off leading spaces, so insert one:
   var Str = new String (" " + this.txtStr);
   var StartPos;

   for ( var tabIx = 0; tabIx < gTextSubstitute.elemTab.length; tabIx++)
      Str = Str.replace(gTextSubstitute.elemTab[tabIx][0], gTextSubstitute.elemTab[tabIx][1]);
   // replace escaped open and close
   Str = Str.replace("\\{", mathSymbol.TEMP_OPEN);
   Str = Str.replace("\\}", mathSymbol.TEMP_CLOSE);
   // remove leading space
   if (Str.charAt(0) == " ") Str = Str.substr(1);
   this.txtStr = Str;
}
// ------------------------------------------------------------------
// Matches opening and closing brackets
// by writing the level of nesting after the bracket
// ------------------------------------------------------------------
function MathExpression_matchBrackets()
{
  var Str = new String(this.txtStr);
  var nx = 0; // nesting level
  // the first character in the ASCII sequence used for indexing brackets
  // chars 127 upwards rarely typable:
  var asciiStart = 127;
  for (var ix = 0; ix < Str.length; ix++)
  {
    if ( Str.charAt(ix) == "{" )
    {
      if (nx > 50) // arbitrarily only allow 50  levels of nesting!!!
                   // avoids clash with mathSymbol constants
      {
        this.errorCode = 2;
        return;
      }
      nx++;
      if (nx > this.maxNest) this.maxNest = nx;
      Str = Str.substring(0,ix+1)+ toASCII(nx+asciiStart) +
          Str.substring(ix+1);
      ix++;
    }
    if (Str.charAt(ix) == "}" )
    {
      Str = Str.substring(0,ix+1)+ toASCII(nx+asciiStart) +
        Str.substring(ix+1);
      nx--;
      if (nx < 0)
      {
        this.errorCode = 3;
        return;
      }
      ix++;
    }
  }
  if (nx != 0)
  {
    this.errorCode = 4;
    return;
  }
  this.txtStr = Str;
}
// ------------------------------------------------------------------
// Inserts brackets for free standing format delimiters
// ------------------------------------------------------------------
function MathExpression_addFormatDelims()
{
  var asciiStart = 127;


  var wString = new String(this.txtStr);
  for (var ix=0; ix < wString.length; ix++)
  {
     if (wScriptString.indexOf (wString.charAt(ix)) > -1)
     {
        // find the first non-script character
        var jx = ix+1;
        while(wScriptString.indexOf (wString.charAt(jx)) > -1) jx++;
        if (jx != ix + 1 && wString.charAt(jx) == "{")
        {
           var wSearch = "}" + wString.charAt(jx + 1);
           var kx = wString.indexOf(wSearch,jx) + 1;
           //alert ("\"" + wString + "\" ix: " + ix  + "\" jx: " + jx + "\" kx: " + kx);
           var nestLevel = ++this.maxNest;
           wString = wString.substr(0,ix+1)
            + "{" + toASCII(nestLevel+asciiStart) + wString.substr(ix + 1,kx - ix)
            + "}" + toASCII(nestLevel+asciiStart) + wString.substr(kx + 1);
        }
        else if (wString.charAt(jx) != "{")
        {
           //alert ("\"" + wString + "\" ix: " + ix  + "\" jx: " + jx);
           var nestLevel = ++this.maxNest;
           wString = wString.substr(0,jx)
            + "{" + toASCII(nestLevel+asciiStart) + wString.charAt(jx)
            + "}" + toASCII(nestLevel+asciiStart) + wString.substr(jx + 1);
            ix--;
        }
     }
  }
  this.txtStr = wString;
}
// ------------------------------------------------------------------
// Replaces long template names with single letter code
// ------------------------------------------------------------------
function MathExpression_insertTemplAbbrev()
{
  var Str = new String (this.txtStr);
  var wx;
  var ix;
  var repExStr;

  for (wx = 0; wx < gTemplateDict.member.length; wx++)
  {
    Str = Str.replace(gTemplateDict.member[wx].name + "{",
       gTemplateDict.member[wx].id + mathSymbol.TEMPLATE_OPEN);
    Str = Str.replace(gTemplateDict.member[wx].name + " {",
       gTemplateDict.member[wx].id + mathSymbol.TEMPLATE_OPEN);
  }
  // replace format delimiters
  var openPos = Str.indexOf("{");
  while (openPos > -1)
  {
     var openPref = "a"
     if (openPos > 0)
        openPref = Str.charAt(openPos - 1);
     if (wScriptString.indexOf(openPref) > -1) // this is a format
        Str = Str.substr(0,openPos) + mathSymbol.FORMAT_OPEN + Str.substr(openPos + 1)
     else
        Str = Str.substr(0,openPos) + mathSymbol.OPEN_DELIMITER + Str.substr(openPos + 1)
     openPos = Str.indexOf("{");
  }

  this.txtStr = Str;
}
// ------------------------------------------------------------------
// replace matrix with rndb array, and det with detOf array
// ------------------------------------------------------------------
function MathExpression_expandMatrix()
{
  var Str = new String (this.txtStr);
  var asciiStart = 127;
  var nestLevel;

  var arrayId = gTemplateDict.getNamedMember("array").id;
  var matrixId = gTemplateDict.getNamedMember("matrix").id;
  var detId = gTemplateDict.getNamedMember("det").id;
  var rndbId = gTemplateDict.getNamedMember("rndb").id;
  var detOfId = gTemplateDict.getNamedMember("detOf").id;

  nestLevel = this.maxNest + 1;
  var wOpen =  matrixId +  mathSymbol.TEMPLATE_OPEN;
  var startPos = Str.indexOf(wOpen);
  while (startPos != -1)
  {
     this.maxNest = nestLevel;
     var lowerLevel = toASCII(nestLevel+asciiStart);
     var templLevel = Str.charAt(startPos+2);
     var wClose = mathSymbol.CLOSE_DELIMITER + templLevel;
     var endPos = Str.indexOf(wClose,startPos);
     var paramStr = Str.substr(startPos, endPos - startPos + 2);
     paramStr =
                rndbId + mathSymbol.TEMPLATE_OPEN + templLevel +
                arrayId  + mathSymbol.TEMPLATE_OPEN + lowerLevel +
                paramStr.substr(3,paramStr.length - 5) +
                mathSymbol.CLOSE_DELIMITER + lowerLevel +
                mathSymbol.CLOSE_DELIMITER + templLevel ;
     Str = Str.substr(0,startPos) + paramStr + Str.substr(endPos+2);
     startPos = Str.indexOf(wOpen);
  }
  var wOpen =  detId +  mathSymbol.TEMPLATE_OPEN;
  var startPos = Str.indexOf(wOpen);
  while (startPos != -1)
  {
     this.maxNest = nestLevel;
     var lowerLevel = toASCII(nestLevel+asciiStart);
     var templLevel = Str.charAt(startPos+2);
     var wClose = mathSymbol.CLOSE_DELIMITER + templLevel;
     var endPos = Str.indexOf(wClose,startPos);
     var paramStr = Str.substr(startPos, endPos - startPos + 2);
     paramStr =
                detOfId + mathSymbol.TEMPLATE_OPEN + templLevel +
                arrayId  + mathSymbol.TEMPLATE_OPEN + lowerLevel +
                paramStr.substr(3,paramStr.length - 5) +
                mathSymbol.CLOSE_DELIMITER + lowerLevel +
                mathSymbol.CLOSE_DELIMITER + templLevel ;
     Str = Str.substr(0,startPos) + paramStr + Str.substr(endPos+2);
     startPos = Str.indexOf(wOpen);
  }

  Str = Str.replace("/", mathSymbol.TEMP_SLASH);

  this.txtStr = Str;
}
// ------------------------------------------------------------------
// Match the parameter separating characters (commas, slashes)
// to the enclosing brackets
// ------------------------------------------------------------------
function MathExpression_matchSeparators(wSeparator)
{
  var wString = new String(this.txtStr);
  var levelId = new Array();
  var isTemplate = new Array();

  var wLev = 0;

  levelId[wLev] = "";
  isTemplate[wLev] = false;

  for (var ix=0; ix < wString.length; ix++)
  {
     var wChar = wString.charAt(ix);
     if (wChar == mathSymbol.TEMPLATE_OPEN)
     {
        wLev++;
        levelId[wLev] = wString.charAt(ix+1);
        if (wSeparator == mathSymbol.TEMP_SLASH)
        {
           if ( wString.charAt(ix-1) == gTemplateDict.getNamedMember("array").id)
              isTemplate[wLev] = true;
           else
              isTemplate[wLev] = false;
        }
        else
           isTemplate[wLev] = true;
     }
     else if (wChar == mathSymbol.OPEN_DELIMITER
             || wChar == mathSymbol.FORMAT_OPEN)
     {
        wLev++;
        levelId[wLev] = wString.charAt(ix+1);
        isTemplate[wLev] = false;
     }
     else if (wChar == mathSymbol.CLOSE_DELIMITER)
     {
        wLev--;
     }
     else if (wChar == wSeparator)
     {
        if (isTemplate[wLev])
           wString = wString.substr(0,ix+1) +
              levelId[wLev] +
              wString.substr(ix+1);
     }
  }
  this.txtStr = wString;
}
// ------------------------------------------------------------------
// creates the dimensioned array templates in the string
// ------------------------------------------------------------------
function MathExpression_manipulateArray()
{

  var Str = new String (this.txtStr);
  var arrayId = gTemplateDict.getNamedMember("array").id;
  var ix = Str.indexOf(arrayId + mathSymbol.TEMPLATE_OPEN);
  // while there are still array templates in the input string
  while (ix > -1)
  {
     var levInd = Str.charAt(ix+2);
     var jx = Str.indexOf(mathSymbol.CLOSE_DELIMITER + levInd,ix);
     var wParms = Str.substr(ix+3,jx-ix-3);
     var wRows = wParms.split(mathSymbol.TEMP_SLASH + levInd);
     var wRowElCount = new Array();
     var newParms = "";
     var colCount = 0;

     // get maximum row length, recording each
     for (var kx = 0; kx < wRows.length; kx++)
     {
        wRowElCount[kx] = wRows[kx].split("," + levInd).length;
        if (wRowElCount[kx] > colCount) colCount = wRowElCount[kx];
     }
     // for each row
     for (var kx = 0; kx < wRows.length; kx++)
     {
        // pad out to get same row length
        for (var hx = wRowElCount[kx]; hx < colCount; hx++)
           wRows[kx] += "," + levInd;
        // stick rows back together with commas in-between (instead of slash)
        newParms += "," + levInd + wRows[kx]
     }
     // find/create the requisite dimensioned lattice template
     var latId = gTemplateDict.findLattice(wRows.length,colCount);
     // put input string back together replacing array template with lattice
     Str = Str.substring(0,ix) + latId + mathSymbol.TEMPLATE_OPEN + levInd +
        newParms.substr(2) + Str.substring(jx);

     ix = Str.indexOf(arrayId + mathSymbol.TEMPLATE_OPEN);
  }

  // now restore the non array slashes
  Str = Str.replace(mathSymbol.TEMP_SLASH, "/");

  this.txtStr = Str;
}

// === Class: cExprNode ===========================================
function cExprNode      // ------------- class definition -----------
   (iParent, iExpr, iLevel)
{
   this.parent = iParent;
   this.nodeType = new (String);
   this.text;
   this.template;
   this.format;
   this.formatDesc;
   this.level = iLevel + 1;
   this.children = new Array();
   this.rowCount = 0;

   this.createPhrase  = cExprNode_createPhrase;
   this.createTempl   = cExprNode_createTempl;
   this.createFmt     = cExprNode_createFmt;

   this.countRows     = cExprNode_countRows;
   this.countText     = cExprNode_countText;
   this.countPhrase   = cExprNode_countPhrase;
   this.countTempl    = cExprNode_countTempl;
   this.countFmt      = cExprNode_countPhrase;

   this.translate     = cExprNode_translate;
   this.transPhrase   = cExprNode_transPhrase;
   this.transTempl    = cExprNode_transTempl;
   this.transFmt      = cExprNode_transFmt;
   this.transText     = cExprNode_transText;

   this.createTD      = cExprNode_createTD;

   var closePos;
   var wExpr = new String(iExpr);
   if ( wExpr.charAt(0) == mathSymbol.OPEN_DELIMITER)
   {
      closePos =
         wExpr.indexOf(mathSymbol.CLOSE_DELIMITER + wExpr.charAt(1));
      if (closePos == wExpr.length - 2)
      // *** if whole string enclosed in delimiters remove these
         wExpr = wExpr.substr(2,wExpr.length - 4);
   }


   if ( wExpr.charAt(1) == mathSymbol.TEMPLATE_OPEN
      || wExpr.charAt(1) == mathSymbol.FORMAT_OPEN)
   // *** if string begins as template or format find closing delimiter
      closePos =
         wExpr.indexOf(mathSymbol.CLOSE_DELIMITER + wExpr.charAt(2));

// *** start processing ***
   if (  wExpr.indexOf(mathSymbol.TEMPLATE_OPEN) == -1
      && wExpr.indexOf(mathSymbol.FORMAT_OPEN) == -1
      && wExpr.indexOf(mathSymbol.OPEN_DELIMITER) == -1)
   // *** no templates or formats - pure text
   {
      this.text = new String(wExpr);
      this.nodeType = eqnTypes.TEXT;
   }
   else if (  wExpr.charAt(1) == mathSymbol.TEMPLATE_OPEN
           && closePos == wExpr.length - 2)
   // *** closing delimiter at end of string - pure template
         this.createTempl(wExpr);
   else if (  wExpr.charAt(1) == mathSymbol.FORMAT_OPEN
           && closePos == wExpr.length - 2)
   // *** closing delimiter at end of string - pure format
      this.createFmt(wExpr);
   else
   // *** complex expression
      this.createPhrase(wExpr);

}
// ------------------------------------------------------------------
// constructor for complex expression node
//   this parses the expression into simple text, format strings,
//   template expressions and delimited expressions.
// ------------------------------------------------------------------
function cExprNode_createPhrase(iExpr)
{
   var wStr = new String(iExpr);
   this.nodeType = eqnTypes.PHRASE;
   var big = 999999999;
   var firstPart;
   var secondPart;

   while (wStr.length != 0)
   {
      var templPos = wStr.indexOf(mathSymbol.TEMPLATE_OPEN);
      var formatPos = wStr.indexOf(mathSymbol.FORMAT_OPEN);
      var delimPos = wStr.indexOf(mathSymbol.OPEN_DELIMITER);
      if (templPos == -1) templPos = big + 9;
      if (formatPos == -1) formatPos = big + 9;
      if (delimPos == -1) delimPos = big + 9;

      var openPos = Math.min (templPos - 1, formatPos - 1, delimPos);

      if (openPos > big) //no template
      {
         firstPart = wStr;
         secondPart = "";
      }
      else if (openPos == 0)
      {
         var closePos =
            (wStr.charAt(0) == mathSymbol.OPEN_DELIMITER)?
               wStr.indexOf(mathSymbol.CLOSE_DELIMITER + wStr.charAt(1)):
               wStr.indexOf(mathSymbol.CLOSE_DELIMITER + wStr.charAt(2));
         firstPart = wStr.substr(0, closePos + 2);
         secondPart = wStr.substr(closePos + 2);
      }
      else
      {
         firstPart = wStr.substr(0, openPos);
         secondPart = wStr.substr(openPos);
      }
      this.children[this.children.length] = new cExprNode
         (this, firstPart, this.level);
      wStr = secondPart;
   }

}
// ------------------------------------------------------------------
// constructor for template node
//   - create the template node
//   - parse the template parameters
// ------------------------------------------------------------------
function cExprNode_createTempl(iExpr)
{
   var wStr = iExpr.substr(3,iExpr.length-5);
   var closePos;
   this.nodeType = eqnTypes.TEMPLATE;
   this.template = gTemplateDict.getMember(iExpr.charAt(0));
   var wSepar = ',' + iExpr.charAt(2);
   closePos = wStr.indexOf(wSepar);
   while (closePos > -1)
   {
      var firstPart = wStr.substr(0, closePos);
      var secondPart = wStr.substr(closePos + 2);
      this.children[this.children.length] = new cExprNode
         (this, firstPart, this.level);
      wStr = secondPart;
      closePos = wStr.indexOf(wSepar);
   }
   this.children[this.children.length] = new cExprNode
      (this, wStr, this.level);

}
// ------------------------------------------------------------------
// constructor for format
//   - create the format node
// ------------------------------------------------------------------
function cExprNode_createFmt(iExpr)
{
   var wStr = iExpr.substr(3,iExpr.length-5);
   this.nodeType = eqnTypes.FORMAT;
   this.format = iExpr.charAt(0);

   if (this.format == mathSymbol.SUPERSCRIPT)
      this.formatDesc = 'superscript';
   if (this.format == mathSymbol.SUBSCRIPT)
      this.formatDesc = 'subscript';
   if (this.format == mathSymbol.BOLD_STYLE)
      this.formatDesc = 'bold';
   if (this.format == mathSymbol.ITALIC_STYLE)
      this.formatDesc = 'italics';
   if (this.format == mathSymbol.CURSIVE_STYLE)
      this.formatDesc = 'cursive';
   if (this.format == mathSymbol.OVERWRITE)
      this.formatDesc = 'overwrite';

   this.children[this.children.length] = new cExprNode
      (this, wStr, this.level);
}
// ------------------------------------------------------------------
// Counts the rows in the node
// ------------------------------------------------------------------
function cExprNode_countRows()
{
   if (this.nodeType == eqnTypes.PHRASE)
      return this.countPhrase();
//   else if (this.nodeType == eqnTypes.EQUATION)
//      return this.countEqn();
   else if (this.nodeType == eqnTypes.TEMPLATE)
      return this.countTempl();
   else if (this.nodeType == eqnTypes.FORMAT)
      return this.countFmt();
   else
      return this.countText();
}
// ------------------------------------------------------------------
// Returns the number of rows for a text element
// ------------------------------------------------------------------
function cExprNode_countText()
{
   this.rowCount = 1;
   return this.rowCount;
}
// ------------------------------------------------------------------
// Returns the number of rows for phrase, format, eqn
// ------------------------------------------------------------------
function cExprNode_countPhrase()
{
   for (var ix = 0; ix < this.children.length; ix++)
   {
      var wCount = this.children[ix].countRows();
      if (wCount > this.rowCount)
         this.rowCount = wCount;
   }
   return this.rowCount;
}
// ------------------------------------------------------------------
// Returns the number of rows for a template element
// ------------------------------------------------------------------
function cExprNode_countTempl()
{
   this.rowCount = 0
   for (var ix=0; ix < this.template.rows; ix++)
   {
      var rowMax = 1;
      for (var jx=0; jx < this.template.cols; jx++)
      {
         var wCount;
         if (!this.template.cell)
            alert (this.template.name + " cell " +  " does not exist");
         if (!this.template.cell[ix])
            alert (this.template.name + " cell " + ix + " does not exist");
         var wCell = this.template.cell[ix][jx];
         if (wCell.val)
            var parmPos = wCell.val.indexOf("%");
         else
            alert (this.template.name + " cell (" + ix + " , " + jx + ") has no value");
         if (parmPos != -1)
         //if (wCell.val.charAt(0) == '%')
         {
            var parmix =  (wCell.val.substr(parmPos + 1,3) - 1);
            var childNode = this.children[parmix];
            wCount = childNode.countRows();
            if (wCell.rowspan > 1)
               wCount -= (wCell.rowspan - 1);
         }
         else
            wCount = 1 ;
         if (wCount > rowMax)
            rowMax = wCount;
      }
      this.rowCount += rowMax;
   }

   return this.rowCount;
}
// ------------------------------------------------------------------
// Creates the HTML to write the node
// ------------------------------------------------------------------
function cExprNode_translate()
{
//   var thisNode;
   if (this.nodeType == eqnTypes.PHRASE)
      return this.transPhrase();
   else if (this.nodeType == eqnTypes.TEMPLATE)
      return this.transTempl();
   else if (this.nodeType == eqnTypes.FORMAT)
      return this.transFmt();
   else
      return this.transText();
}
// ------------------------------------------------------------------
// translate an phrase node  (i.e. the complete expression)
// ------------------------------------------------------------------
function cExprNode_transPhrase()
{
   var thisNode = document.createElement('span');
   for (var ix = 0; ix < this.children.length; ix++)
   {
      var childNode = this.children[ix].translate();
      thisNode.appendChild(childNode);
   }
   return thisNode;
}
// ------------------------------------------------------------------
// translate an template node
// ------------------------------------------------------------------
function cExprNode_transTempl()
{
   var thisNode = document.createElement("table");
   thisNode.setAttribute("className","mathymaTempl");
   thisNode.style.display = "inline";
   thisNode.style.verticalAlign = "middle";
   thisNode.setAttribute("whiteSpace","nowrap");
   thisNode.setAttribute("cellSpacing","0");
//   thisNode.setAttribute("cellPadding","0");
   thisNode.setAttribute("border","0");
   if (gMySys.diagnosticLevel & diagnostics.GRID)
   {
      thisNode.setAttribute("cellSpacing","5");
      thisNode.setAttribute("cellPadding","5");
      thisNode.setAttribute("border","1");
      thisNode.style.borderColor = "blue";
      thisNode.style.borderStyle = "solid";
      thisNode.style.borderWidth = "2px";
   }
   var tbodyNode = document.createElement('tbody');
   for (var ix=0; ix < this.template.rows; ix++)
   {
      var rowNode = document.createElement('tr');
      for (var jx=0; jx < this.template.cols; jx++)
      {
         var wCell = this.template.cell[ix][jx];
         var eltNode = this.createTD(wCell);
         if (gMySys.diagnosticLevel & diagnostics.GRID)
         {
            eltNode.style.borderColor = "red";
            eltNode.style.borderStyle = "solid";
         }
         if (wCell.type == "W")
         // repeatable text
         {
            if (this.rowCount == 1)
               eltNode.appendChild(xzSpeCharDom(wCell.val));

            else
            {
               var wRpt;
               if (this.rowCount > this.template.rows)
                 wRpt =  this.rowCount - this.template.rows + 1;
               else
                  wRpt = 1;
               var RptTab = document.createElement("table");
               RptTab.setAttribute("whiteSpace","nowrap");
               RptTab.setAttribute("cellSpacing","0");
               RptTab.setAttribute("cellPadding","0");
               RptTab.setAttribute("border","0");
               if (gMySys.diagnosticLevel & diagnostics.GRID)
               {
                  RptTab.setAttribute("cellSpacing","3");
                  RptTab.setAttribute("cellPadding","3");
                  RptTab.setAttribute("border","1");
                  RptTab.style.borderColor = "#0c0";
                  RptTab.style.borderStyle = "solid";
                  RptTab.style.borderWidth = "2px";
               }
               var RptBdy = document.createElement("tbody");
               for (var wRx = 0; wRx < wRpt; wRx++)
               {
                  var RptRow = document.createElement("tr");
                  var RptElt = document.createElement("td");
                  if (gMySys.diagnosticLevel & diagnostics.GRID)
                  {
                     RptElt.style.borderColor = "red";
                     RptElt.style.borderStyle = "solid";
                  }
                  RptElt.appendChild(xzSpeCharDom(wCell.val));
                  RptRow.appendChild(RptElt);
                  RptBdy.appendChild(RptRow);
               }
               RptTab.appendChild(RptBdy);
               eltNode.appendChild(RptTab);
            }
         }
         else if (wCell.type == "B")
         // blank space
         {
        //    eltNode.setAttribute("width",wCell.val + "px");
            for (var bix=0; bix < wCell.val/5; bix++)
//              eltNode.insertAdjacentHTML("AfterBegin"," ");
              eltNode.insertBefore(document.createTextNode(" "),eltNode.childNodes[0]);
         }
         else if (wCell.type == "H")
         // horizontal line
         {
            var HorizLine = document.createElement("hr");
            HorizLine.setAttribute("size","1",
               "color","black","noshade","");
            eltNode.appendChild(HorizLine);
         }
         else if (wCell.type == "S")
         // scaleable
         {
            var wRpt;
            if (this.rowCount > this.template.rows)
              wRpt =  this.rowCount - this.template.rows + 1;
            else
               wRpt = 1;
            if (wRpt > 1)
            {
               eltNode.style.fontSize = "" + (wRpt*100) + "%";
            }
            // ---
            var parmPos = wCell.val.indexOf("%");
            if (parmPos == -1)
               eltNode.appendChild(xzSpeCharDom(wCell.val));
            else
            {
               var parmIx =  (wCell.val.substr(parmPos + 1,3) - 1);
               if (parmPos != 0)   // there's text in front
               {
                  eltNode.insertBefore(xzSpeCharDom(wCell.val.substr(0,parmPos)),eltNode.childNodes[0]);
               }
               var childNode = this.children[parmIx].translate();
               eltNode.appendChild(childNode);
               if (wCell.val.length != parmPos + 4 )   // there's text at the end
               {
                  eltNode.appendChild(xzSpeCharDom(wCell.val.substr(parmPos+4)));
               }
            }
/*
            if (wCell.val.charAt(0) != '%')
               eltNode.appendChild(xzSpeCharDom(wCell.val));
            else
            {
               var parmIx =  (wCell.val.substr(1) - 1);
               var childNode = this.children[parmIx].translate();
               eltNode.appendChild(childNode);
            }
*/
         }
         else if ("TXF".indexOf(wCell.type) != -1)
         // expression or template
         {
            // ---
            var parmPos = wCell.val.indexOf("%");
            if (parmPos == -1)
               eltNode.appendChild(xzSpeCharDom(wCell.val));
            else
            {
               var parmIx =  (wCell.val.substr(parmPos + 1,3) - 1);
               if (parmPos != 0)   // there's text in front
               {
                  eltNode.insertBefore(xzSpeCharDom(wCell.val.substr(0,parmPos)),eltNode.childNodes[0]);
               }
               var childNode = this.children[parmIx].translate();
               eltNode.appendChild(childNode);
               if (wCell.val.length != parmPos + 4 )   // there's text at the end
               {
                  eltNode.appendChild(xzSpeCharDom(wCell.val.substr(parmPos+4)));
               }
            }
/*
            if (wCell.val.charAt(0) != '%')
               eltNode.appendChild(xzSpeCharDom(wCell.val));
            else
            {
               var parmIx =  (wCell.val.substr(1) - 1);
               var childNode = this.children[parmIx].translate();
               eltNode.appendChild(childNode);
            }
*/
         }
         if (wCell.type != "N")
         rowNode.appendChild(eltNode);
      }
      tbodyNode.appendChild(rowNode);
   }
   thisNode.appendChild(tbodyNode);
   return thisNode;
}
// ------------------------------------------------------------------
// translate a format node
// ------------------------------------------------------------------
function cExprNode_transFmt()
{
   var thisNode = document.createElement('span');
   // above is default for undefined format
   if (this.format ==  mathSymbol.SUPERSCRIPT)
      thisNode = document.createElement('sup');
   if (this.format == mathSymbol.SUBSCRIPT)
      thisNode = document.createElement('sub');
   if (this.format == mathSymbol.BOLD_STYLE)
      thisNode = document.createElement('b');
   if (this.format == mathSymbol.ITALIC_STYLE)
      thisNode = document.createElement('i');
   if (this.format == mathSymbol.CURSIVE_STYLE)
   {
      thisNode = document.createElement('span');
      thisNode.style.fontFamily = "cursive";
      thisNode.style.fontStyle = "italic";
      thisNode.style.fontSize = "larger";
   }
   if (this.format == mathSymbol.OVERWRITE)
   {
      thisNode = document.createElement('span');
      thisNode.style.textDecoration = "overline";
   }
   var childNode = this.children[0].translate();
   thisNode.appendChild(childNode);
   return thisNode;
}
// ------------------------------------------------------------------
// translate a text node
// ------------------------------------------------------------------
function cExprNode_transText()
{
   var thisNode = document.createElement('span');
   thisNode.appendChild(zSpeCharDom(this.text));

   return thisNode;
}
// ------------------------------------------------------------------
// create a table cell (TD)
// ------------------------------------------------------------------
function cExprNode_createTD(wCell)
{
   var eltNode = document.createElement('td');
   eltNode.style.whiteSpace = "nowrap";
   if (wCell.rowspan > 1)
      eltNode.setAttribute("rowSpan",wCell.rowspan);
   if (wCell.colspan != 1)
      eltNode.setAttribute("colSpan",wCell.colspan);
//   if (wCell.font == "S")
//      eltNode.style.fontFamily = "symbol";
   if (wCell.scale != 1)
      eltNode.style.fontSize = (wCell.scale * 100) + "%" ;

   if (wCell.horizAlign == "L")
      eltNode.setAttribute("align","left"  );
   else if (wCell.horizAlign == "C")
      eltNode.setAttribute("align","center"  );
   else if (wCell.horizAlign == "R")
      eltNode.setAttribute("align","right"  );

   if (wCell.vertAlign == "T")
      eltNode.style.verticalAlign = "top";
   else if (wCell.vertAlign == "M")
      eltNode.style.verticalAlign = "middle";
   else if (wCell.vertAlign == "B")
      eltNode.style.verticalAlign = "bottom";

   if (wCell.style)
   {
      var wStyles = new Array();
      wStyles = wCell.style.split(";");
      for (var ix = 0; ix < wStyles.length; ix++)
      {
         var comps = wStyles[ix].split(":");
         var wString = "eltNode.style." + comps[0] + " = \"" + comps[1] + "\";" ;
         eval (wString);
      }
   }

   return eltNode;
}
// === Class: HexTable =============================================
// This is a table of table of hex values for ASCII characters 0 - 256
// for use in the hex dump method
// ------------------------------------------------------------------
function HexTable ()     // ------------- class definition -----------
{
  // attributes
  this.charArr = new Array (256);

  // methods
  this.build         = HexTable_build;

  // constructor
  this.build();
}
// ------------------------------------------------------------------
// builds a table of hex values for ASCII characters 0 - 256
// ------------------------------------------------------------------
function HexTable_build()
{
  var hexStr = new String("0123456789ABCDEF");
  for (var ix = 0; ix < 256; ix++)
  {
    this.charArr[ix] = new Array(3);
    var upperHex = hexStr.charAt(Math.floor(ix/16));
    this.charArr[ix][1] = upperHex;
    var lowerHex = hexStr.charAt(ix - (16 * Math.floor(ix/16)));
    this.charArr[ix][2] = lowerHex;
    var wexpr = "this.charArr[ix][0] = \"\\x" + upperHex + lowerHex + "\"";
    eval(wexpr);
  }
}
// === Class: cTextSubstitute =============================================
// A table of text strings and their replacement mathyma strings
// this is used to translate "shorthand" text to the correct
// Mathyma input text.
// ------------------------------------------------------------------
function cTextSubstitute () // ------------- class definition -----------
{
  this.elemTab = new Array();

  // methods
  this.build        = cTextSubstitute_build;

  this.build();
}
// ------------------------------------------------------------------
// builds table of symbol substitution
// ------------------------------------------------------------------
function cTextSubstitute_build()
{
   //alert ("cTextSubstitute.build");
   var tabIx = 0;

   this.elemTab[tabIx++] = new Array("\\_",    "&uscore.");
//   this.elemTab[tabIx++] = new Array(" = ",   " &eq. ");
   this.elemTab[tabIx++] = new Array(" != ",  " &ne. ");
   this.elemTab[tabIx++] = new Array(" > ",   " &gt. ");
   this.elemTab[tabIx++] = new Array(" < ",   " &lt. ");
   this.elemTab[tabIx++] = new Array(" =< ",  " &le. ");
   this.elemTab[tabIx++] = new Array(" >= ",  " &ge. ");
   this.elemTab[tabIx++] = new Array(" ~ ",   " &tilde. ");
   this.elemTab[tabIx++] = new Array(" ~~ ",  " &approx. ");
   this.elemTab[tabIx++] = new Array(" ~= ",  " &cong. ");
   this.elemTab[tabIx++] = new Array(" == ",  " &equiv. ");

   this.elemTab[tabIx++] = new Array(" <= ",  " &if. ");
   this.elemTab[tabIx++] = new Array(" => ",  " &imply. ");
   this.elemTab[tabIx++] = new Array(" <=> ", " &iff. ");
//   this.elemTab[tabIx++] = new Array(" || ",   " #{||} ");
   this.elemTab[tabIx++] = new Array("|",   "&vdash.");
   this.elemTab[tabIx++] = new Array("&vdash.&vdash.","||");
   this.elemTab[tabIx++] = new Array(" -- ",  " &hdash. ");

   this.elemTab[tabIx++] = new Array("+-",    "&pm.");
   this.elemTab[tabIx++] = new Array("+/-",   "&plus./&minus.");
   this.elemTab[tabIx++] = new Array(" # ",   " &times. ");
   this.elemTab[tabIx++] = new Array(" -: ",  " &div. ");
   this.elemTab[tabIx++] = new Array(" ./ ",  " &fslash. ");
   this.elemTab[tabIx++] = new Array(" .// ",  " &fslash.&fslash. ");
   this.elemTab[tabIx++] = new Array(" o+ ",  " &oplus. ");
   this.elemTab[tabIx++] = new Array(" o# ",  " &omult. ");

   this.elemTab[tabIx++] = new Array(" 1/2 ", " &hlf. ");
   this.elemTab[tabIx++] = new Array(" 1/4 ", " &qrt. ");
   this.elemTab[tabIx++] = new Array(" 3/4 ", " &threeqrt. ");

   this.elemTab[tabIx++] = new Array(" -> ",  " &rightarrow. ");
   this.elemTab[tabIx++] = new Array(" <- ",  " &leftarrow. ");
   this.elemTab[tabIx++] = new Array(" <-> ", " &doublearrow. ");
   this.elemTab[tabIx++] = new Array(" --> ", " &hdash.&rightarrow. ");
   this.elemTab[tabIx++] = new Array(" <-- ", " &leftarrow.&hdash. ");
   this.elemTab[tabIx++] = new Array(" <--> ", " &leftarrow.&rightarrow. ");

   this.elemTab[tabIx++] = new Array("_ ",   "   ");
   this.elemTab[tabIx++] = new Array(" ... ", " &elipsis. ");

   this.elemTab[tabIx++] = new Array(" -",     " {&minus.}");
   this.elemTab[tabIx++] = new Array("- ",     "{&minus.} ");
   this.elemTab[tabIx++] = new Array("{-}",     "{&minus.}");
   this.elemTab[tabIx++] = new Array("{-",     "{&minus.");

   this.elemTab[tabIx++] = new Array("&est.",     "^#{&hat.}");
   this.elemTab[tabIx++] = new Array("&comp.",     "_#{&circle.}");
   this.elemTab[tabIx++] = new Array("&reals.",    "IR");
   this.elemTab[tabIx++] = new Array("&naturals.", "IN");
   this.elemTab[tabIx++] = new Array("&complex.",  "C");
   this.elemTab[tabIx++] = new Array("&integers.", "Z");
   this.elemTab[tabIx++] = new Array("&spot.",     "#.");
   this.elemTab[tabIx++] = new Array("&uparrow.",     "&uarr.");
   this.elemTab[tabIx++] = new Array("&br.",     "<br/>");

}
// === Class: cTemplateDict ===========================================
//
// ------------------------------------------------------------------
function cTemplateDict () // ------------- class definition -----------
{
  this.idListSource = new String ("abcdefghijklmnopqrstuvwxyz"
                           + "ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  this.idList = new String ("");
  this.member = new Array();
  this.displayed = false;

  // methods:
  this.load            = cTemplateDict_load;
  this.sortMembers     = cTemplateDict_sortMembers;
  this.loadTemplate    = cTemplateDict_loadTemplate;
  this.getMember       = cTemplateDict_getMember;
  this.getNamedMember  = cTemplateDict_getNamedMember;
  this.findLattice     = cTemplateDict_findLattice;

  // constructor
  this.load();
}
// ------------------------------------------------------------------
// cTemplateDict method:  loads the Dictionary of valid templates
// ------------------------------------------------------------------
function cTemplateDict_load()
{
   //alert ("cTemplateDict.load");
   var wTemplate;
   var iInputFile;

   // fix to avoid access problems while developing offline
   if (wMathymaLib.substr(0,5).toUpperCase() == "FILE:")
      iInputFile = "MathymaTemplates.xml";
   else
      iInputFile = wMathymaLib + "MathymaTemplates.xml";

   var xmlDoc = openXMLhttp (iInputFile);

   var xTemplateTabs = xmlDoc.getElementsByTagName("Template");
   //alert ("there are "+xTemplateTabs.length+" templates");

   for (var templIx = 0; templIx < xTemplateTabs.length ; templIx++)
//   for (var templIx = 12; templIx < 13 ; templIx++) // **** TEMPORARY fault finding ****** //
      this.loadTemplate(xTemplateTabs[templIx]);

   this.sortMembers();
}
// ------------------------------------------------------------------
// cTemplateDict method:  sorts the member list by reverse name length
//     This is to prevent e.g. "dblint{}" being interpreted as
//     "dbl" + "int{}"
// ------------------------------------------------------------------
function cTemplateDict_sortMembers()
{
   var wTemplist = new Array;
   for (var ix = 0; ix < this.member.length; ix++)
   {
      wTemplist[ix] = new Array(2);
      wTemplist[ix][1] = this.member[ix];
//      wTemplist[ix][2] = this.idList.charAt(ix);
      wTemplist[ix][0] = 1000 - this.member[ix].name.length;
   }
   wTemplist = wTemplist.sort();
   this.member = new Array;
   this.idList = new String("");
   for (var ix = 0; ix < wTemplist.length; ix++)
   {
      this.member[ix] = wTemplist[ix][1];
      this.idList += this.member[ix].id;
   }
}
// ------------------------------------------------------------------
// cTemplateDict method:  loads the individual template
// ------------------------------------------------------------------
function cTemplateDict_loadTemplate(xTemplate)
{
   // template attributes
   var wName;
   var wRowCount;
   var wColCount;
   var wDescript;

   var wEltIx = 0;
   // element properties
   var wERow  = new Array();
   var wECol  = new Array();
   var wEType = new Array();
   var wEVal = new Array();
   var wEVlu  = new Array();
   var wEFont  = new Array();
   var wEScale  = new Array();
   var wEVertAlign  = new Array();
   var wEHorizAlign  = new Array();
   var wERowspan  = new Array();
   var wEColspan  = new Array();
   var wEStyle  = new Array();

   //alert ("template has " + xTemplate.childNodes.length + " child nodes");
   // first read in all template attributes and elements from XML;
   for (var attrIx = 0; attrIx < xTemplate.childNodes.length ; attrIx++)
   {
      var xAttribute = xTemplate.childNodes[attrIx];
      var xAttributeVal;
      if (xAttribute.text )
         xAttributeVal = xAttribute.text;
      else if (xAttribute.childNodes[0] && xAttribute.childNodes[0].nodeValue)
         xAttributeVal= xAttribute.childNodes[0].nodeValue;
      if (xAttribute.nodeName == "#text"); //ignore
      else if (xAttribute.nodeName == "Name")
         wName = xAttributeVal;
      else if (xAttribute.nodeName == "RowCount")
         wRowCount = xAttributeVal;
      else if (xAttribute.nodeName == "ColCount")
         wColCount = xAttributeVal;
      else if (xAttribute.nodeName == "Descript")
         wDescript = xAttributeVal;
      else if (xAttribute.nodeName == "Element")
      {
         wEltIx = wEFont.length;
         wEFont[wEltIx] = "N"; // default in case of non define
         for (var eltPropIx = 0; eltPropIx < xAttribute.childNodes.length ; eltPropIx++)
         {
            var xEltProp = xAttribute.childNodes[eltPropIx];
            // alert("elt. name" + xEltProp.nodeName);
            var xEltPropVal;
            if (xEltProp.text)
               xEltPropVal = xEltProp.text;
            else if (xEltProp.childNodes[0] && xEltProp.childNodes[0].nodeValue)
               xEltPropVal= xEltProp.childNodes[0].nodeValue;
            if (xEltProp.nodeName == "#text"); // ignore
            else if (xEltProp.nodeName == "ERow")
               wERow[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "ECol")
               wECol[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "EVal")
               wEVal[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "EType")
               wEType[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "EFont")
               wEFont[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "EScale")
               wEScale[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "EVertAlign")
               wEVertAlign[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "EHorizAlign")
               wEHorizAlign[wEltIx] = xEltPropVal;
            else if (xEltProp.nodeName == "ERowspan")
               wERowspan[wEltIx] = Number(xEltPropVal);
            else if (xEltProp.nodeName == "EColspan")
               wEColspan[wEltIx] = Number(xEltPropVal) ;
            else if (xEltProp.nodeName == "EStyle")
            {
               if (!wEStyle[wEltIx])
                  wEStyle[wEltIx] = xEltPropVal ;
               else
                  wEStyle[wEltIx] += ";" + xEltPropVal ;
            }
            else
               alert("Template: " + wName + ". Error: unknown element property: "
                  + xEltProp.nodeName + " = " + xEltPropVal);
         }
      }
      else
         alert("Template: " + wName + ". Error: unknown attribute: "
           + xAttribute.nodeName + " = " + xAttributeVal);
   }

   wTemplateId = this.idListSource.charAt(this.member.length);
//   if (wTemplateId != 'X') bTraceFlag = true;
   this.idList += wTemplateId;
   if (bTraceFlag)
      alert("cTemplate (" + wName + ", " + wRowCount + ", " + wColCount + ", \"" + wDescript +
      "\", " + wTemplateId + ")\nhas " + wEFont.length + " elements");
   var wTemplate = new cTemplate (wName , wRowCount, wColCount, wDescript, wTemplateId);
   this.member[this.member.length] = wTemplate;
   for (var eltIx = 0; eltIx < wEFont.length; eltIx++)
   {
      if (bTraceFlag)
         alert("wTemplate.addElt(" + wERow[eltIx] + ", " + wECol[eltIx] + ", " + wEType[eltIx]
          + ", " +  wEVal[eltIx] + ", " +  wEFont[eltIx] + ") "  );
      var wTemplateElt = wTemplate.addElt( wERow[eltIx], wECol[eltIx], wEType[eltIx], wEVal[eltIx], wEFont[eltIx]);

      if (wEScale[eltIx] )
         wTemplateElt.scale = wEScale[eltIx];
      if (wEVertAlign[eltIx]  )
         wTemplateElt.vertAlign = wEVertAlign[eltIx];
      if (wEHorizAlign[eltIx]  )
         wTemplateElt.horizAlign = wEHorizAlign[eltIx];
      if (wERowspan[eltIx]  )
         wTemplateElt.rowspan = wERowspan[eltIx];
      if (wEColspan[eltIx]  )
         wTemplateElt.colspan = wEColspan[eltIx];
      if (wEStyle[eltIx]  )
         wTemplateElt.style = wEStyle[eltIx];
   }
   wTemplate.build();
//   bTraceFlag = false;
}
// ------------------------------------------------------------------
// cTemplateDict method for getting a template with given id.
// ------------------------------------------------------------------
function cTemplateDict_getMember (iMembId)
{
  var ix = this.idList.indexOf(iMembId);
  if (ix > -1 && ix < this.member.length)
    return this.member[ix];
  else
    alert("Cannot find dictionary member with id: "
      + iMembId );
}
// ------------------------------------------------------------------
// cTemplateDict method for getting a template with given name
// ------------------------------------------------------------------
function cTemplateDict_getNamedMember (iName)
{
  var ix;
  for (ix =0; ix < this.member.length && this.member[ix].name != iName;ix++);
  if ( ix < this.member.length)
    return this.member[ix];
  else
    return -1;
}
// ------------------------------------------------------------------
// Finds or creates different dimensioned lattices
// ------------------------------------------------------------------
function cTemplateDict_findLattice(iLatX,iLatY)
{
  var wx;
  var ix;
  var iy;
  var wParm;
  wTemplName = "_lat_" + iLatX + "_by_" + iLatY ;
  wTemplDesc = iLatX + " by " + iLatY + " lattice (array)";
  //alert("finding " + wTemplDesc);

  var wTemplateId;
  var wTemplate = this.getNamedMember(wTemplName);
  if (wTemplate == -1)
  {
    wTemplateId = this.idListSource.charAt(this.member.length);
    this.idList += wTemplateId;
    var wTemplate = new cTemplate (wTemplName , iLatX, (2*iLatY)-1, wTemplDesc, wTemplateId);
    this.member[this.member.length] = wTemplate;
    for (ix = 0; ix < iLatX; ix++)
    {
      for (iy = 0; iy < iLatY; iy++)
      {
        wParm = (ix * iLatY) + iy + 1;
        wTemplate.addElt( ix, 2*iy, "X", "%" + wParm, "");
        if (iy < (iLatY - 1) )
          wTemplate.addElt( ix, (2*iy)+1, "B", "5", "");
      }
    }
    wTemplate.build();
  }
  else
    wTemplateId = wTemplate.id;
  return wTemplateId;
}
// === Class: cTemplate ===========================================
//
// ------------------------------------------------------------------
function cTemplate      // ------------- class definition -----------
   (iName, iRows, iCols, iDesc, iId)
{
  this.name = iName;
  this.rows = iRows;
  this.cols = iCols;
  this.parms = 0;
  this.desc = iDesc;
  this.id = iId;
  this.elt = new Array ();
  this.cell = new Array ();
  this.built = false;

  // methods
  this.addElt = cTemplate_addElt;
  this.build = cTemplate_build;

//  this.print = cTemplate_print;

}
// ------------------------------------------------------------------
// cTemplate method for adding an element to the cTemplate object
// ------------------------------------------------------------------
function cTemplate_addElt(iRow, iCol, iType, iVal, iFont)
{
  //alert("cTemplate_addElt( " + iRow +", "+ iCol +", "+ iType +", "+ iVal +", "+ iFont +") ");
  // get highest parameter
  var wPos;
  if (iVal == undefined)
     wPos = - 1
  else
     wPos  =  iVal.indexOf("%");
  if (wPos > -1)
  {
    var parmIx = iVal.substr(wPos + 1,3);
    if (parmIx > this.parms)
      this.parms = parmIx;
  }
  return this.elt[this.elt.length] =
     new cTemplateCell(iRow, iCol, iType, iVal, iFont);
}
// ------------------------------------------------------------------
// cTemplate method for building matrix of template cells
// ------------------------------------------------------------------
function cTemplate_build()
{

  var wEmpty = new cTemplateCell(0, 0, "E", "e","", 1, 1);
  var wNull = new cTemplateCell(0, 0, "N", "*","", 0, 0);

  // initialize template matrix
  for (var ix = 0; ix < this.rows; ix++)
  {
    this.cell[ix] = new Array(this.cols);
    for (jx = 0; jx < this.cols; jx++)
    {
      this.cell[ix][jx] = wEmpty;
    }
  }

  // tranfer info from elt list to cell grid
  for (var ix = 0; ix < this.elt.length; ix ++)
  {
     wTempElt = this.elt[ix];
     // assign the definition element to the matrix cell
     this.cell[wTempElt.row][wTempElt.col] = wTempElt;

     // initialize null cells due to colspan or rowspan
     if ((wTempElt.rowspan > 1) || (wTempElt.colspan > 1))
     {
       for (jx = 0; jx < wTempElt.rowspan; jx++)
       {
         for (kx = 0; kx < wTempElt.colspan; kx++)
         {
           if (!(jx == 0 && kx == 0))
           {
             var wRef = "*[" + wTempElt.row + "][" + wTempElt.col + "]";
             var wTrow = Number(wTempElt.row) + jx;
             var wTcol = Number(wTempElt.col) + kx;
             if (this.cell[wTrow] == undefined)
               this.cell[wTrow] = new Array(this.cols);
             this.cell [wTrow][wTcol] = wNull;
           }
         }
       }
     }
   }
}

// ====================================================================
//  Class: cTemplateCell.
//    Templatetion Element. Each template will have a number of elements.
//    A template element describes what is to be printed in an
//    individual cell of the template matrix. This can be a literal
//    expression (defined in this.val), a variable (one of the template
//    arguments designated by %001, %002, etc), or an expression (also
//    defined by one of the arguments, etc. (see this.type below)
// ====================================================================
function cTemplateCell  // ------------- class definition -----------
   (iRow, iCol, iType, iVal, iFont)
{
  this.row = iRow;   // Note the first cell is row 0, col 0.
  this.col = iCol;
  this.type = iType; // 'S' - scaleable (stretch) text
                     // 'T' - fixed text
                     // 'B' - blank space
                     // 'X' - a (sub-)expression (also from args)
                     // 'H' - a horiziontal rule (as over- or under- lining)
                     // 'W' - vertically repeated text (e.g. | )
       // system adds these types in the actual equation element:
                     // 'F' - template
                     // 'R' - template row
                     // 'E' - empty cell
                     // 'N' - non-used cell (due to row- or col- span)
  this.val = iVal;   // a given literal value, or:
                     // a template argument ("%001", "%002", ...)
//  this.font = iFont; // only if val is literal: N - normal, S - symbol
//  if (this.font == "") this.font = "N";
  this.rowspan = 1;
  this.colspan = 1;
  this.scale = 1;
  this.vertAlign = "M";  //T-top, M-middle, B-bottom
  this.horizAlign = "C"; //L-left, C-centre, R-right
  this.style = "";

  // methods
  this.print = cTemplateCell_Print;
}
// --------------------------------------------------------------------
// cTemplateCell method
//   prints template def. element as a row in the table
// --------------------------------------------------------------------
function cTemplateCell_Print ()
{
  document.write ("<tr>"
    + "<td>" + this.row + "</td>"
    + "<td>" + this.col + "</td>"
    + "<td>" + this.type + "</td>"
    );
//  if (this.font == "S")
//    document.write("<td style=\"font-family: symbol\">");
//  else if (this.font == "A")
//    document.write("<td style=\"font-family: sans-serif\">");
//  else
    document.write("<td>");
  document.write(" "
     + this.val + "</td>"
    + "<td>" + this.font + "</td>"
    + "<td>" + this.rowspan + "</td>"
    + "<td>" + this.colspan + "</td>"
    + "<td>" + this.scale + "</td>"
    + "<td>" + this.vertAlign + "</td>"
    + "<td>" + this.horizAlign + "</td>"
    + "</tr>");
}
// ====================================================================
//  Class: cSymbolDict
//    A dictionary of all the symbols used in equation writer.
// ====================================================================
function cSymbolDict () // ------------- class definition -----------
{
  this.member = new Array();
  this.displayed = false;
  // methods
  this.addSymbol    = cSymbolDict_addSymbol;
  this.build        = cSymbolDict_build;
  this.locate       = cSymbolDict_locate;
  this.getSymbol    = cSymbolDict_getSymbol;

  this.build();
}

var gSymbolDict = new cSymbolDict;

// --------------------------------------------------------------------
// cSymbolDict method for adding a template to the dictionary
// --------------------------------------------------------------------
function cSymbolDict_addSymbol (iAbbr, iSymb, iFont, iUcode)
{
  return this.member[this.member.length]
    = new cSymbol (iAbbr, iSymb, iFont, iUcode);
}
// --------------------------------------------------------------------
// cSymbolDict method to build the dictionary
// --------------------------------------------------------------------
function cSymbolDict_build()
{
 //  var xmlDoc = new ActiveXObject("Microsoft.XMLDOM")

   // fix to avoid access problems while developing offline
   if (wMathymaLib.substr(0,5).toUpperCase() == "FILE:")
      iInputFile = "MathymaSymbs.xml";
   else
      iInputFile = wMathymaLib + "MathymaSymbs.xml";

   var xmlDoc = openXMLhttp (iInputFile);

   var xSymbTab = xmlDoc.getElementsByTagName("Symbol");
   for (var symbIx = 0; symbIx < xSymbTab.length ; symbIx++)
   {
      var xSymb = xSymbTab[symbIx];
      // Symbol attributes
      var wName;
      var wValue;
      var wUcode;
      var wFont = "N";
      for (var attrIx = 0; attrIx < xSymb.childNodes.length ; attrIx++)
      {
         var xAttribute = xSymb.childNodes[attrIx];
         var xAttributeVal;
         if (xAttribute.text )
            xAttributeVal = xAttribute.text;
         else if (xAttribute.childNodes[0] && xAttribute.childNodes[0].nodeValue)
            xAttributeVal= xAttribute.childNodes[0].nodeValue;
         if (xAttribute.nodeName == "#text"); // ignore
         else if (xAttribute.nodeName == "Name")
            wName = xAttributeVal;
         else if (xAttribute.nodeName == "Value")
            wValue = xAttributeVal;
         else if (xAttribute.nodeName == "Ucode")
            wUcode = xAttributeVal;
         else if (xAttribute.nodeName == "Font")
            wFont = xAttributeVal;
         else
            document.write("<br/>Symbol: <b>" + wName + "</b>. Error: unknown attribute: " +
               xAttribute.nodeName + " = " + xAttributeVal);
      }

      if (wName == undefined || wValue == undefined )
         document.write("<br/>Symbol not completely defined: <b>" + wName + " == " + wValue);
      else
      {
         if (wFont == "R")
         {
            wValue = "&" + wValue + ".";
            wFont = "N";
         }
         this.addSymbol(wName, wValue, wFont, wUcode);
      }
   }

}
// --------------------------------------------------------------------
// cSymbolDict method locates the symbols with the given abbreviation
// --------------------------------------------------------------------
function cSymbolDict_locate(iAbbr)
{
  var qwx = -1;
  for (var qix = 0; qix < this.member.length; qix++)
  {
    if (this.member[qix].abbr == iAbbr)
      qwx = qix;
  }
  return qwx;
}
// --------------------------------------------------------------------
// cSymbolDict method returns the HTML string for the given index
// --------------------------------------------------------------------
function cSymbolDict_getSymbol(iIx)
{
/*
*/
   if (gBrowserName.toUpperCase().indexOf("NETSCAPE") > -1)
   {
      var spChar;
      var wCommand = "spChar = \"\\u" + this.member[iIx].ucode + "\";";
      eval (wCommand);
      return document.createTextNode(spChar);
   }
   else
   {
      var spanNode  = document.createElement('span');
      if (this.member[iIx].font == "S")
         spanNode.style.fontFamily = "symbol";
      else if (this.member[iIx].font == "N")
         spanNode.style.fontFamily = "normal";
      spanNode.appendChild(document.createTextNode(hexString.charAt(this.member[iIx].symb)));
      return spanNode;
   }

}
function cSymbolDict_getSymbolOLD(iIx)
{
  var wStr = new String ();
  if (this.member[iIx].font == "S")
    wStr = "<span style=\"font-family:symbol\">&#"
      + this.member[iIx].symb + ";</span>";
  else if (this.member[iIx].font == "N")
    wStr = "<span style=\"font-family:normal\">&#"
      + this.member[iIx].symb + ";</span>";
  else
    wStr = "&#" + this.member[iIx].symb + ";";
//  if (this.member[iIx].font  == "N") alert (this.member[iIx].abbr + "\n" + this.member[iIx].symb);
  return wStr;
}
// ====================================================================
//  Class: cSymbol
//    The definition of a symbol used in equation text.
//    Each definition consists of the abreviation which will be typed
//    in the source HTML (prefixed by '&' and followed by ';'), the
//    character value of the symbol, and the font or characterset from
//    which the symbol is drawn, i.e. 'N'ormal or 'S'ymbol.
// ====================================================================
function cSymbol        // ------------- class definition -----------
(iAbbr, iSymb, iFont, iUcode)
{
  this.abbr = iAbbr;
  this.symb = iSymb;
  this.font = iFont;
  this.ucode = iUcode;
}
// ------------------------------------------------------------------
// replace the sub-string wSearch with the sub-string wRepl
// throughout the given string
// ------------------------------------------------------------------
function String_replace (wSearch, wRepl)
{
   var Str = new String(this);
   var StartPos = Str.indexOf(wSearch);
   while (StartPos != -1)
   {
      var EndPos = StartPos + wSearch.length;
      Str = Str.substr(0,StartPos) + wRepl + Str.substr(EndPos);
      StartPos = Str.indexOf(wSearch,StartPos+wRepl.length);
   }
   return Str;
}
// ------------------------------------------------------------------
// returns the relative path from the document to this script file
// this module must be called on load of the script file.
// ------------------------------------------------------------------
function getRelDir()
{
   var docScripts = document.getElementsByTagName("script");
   var myPath = docScripts[docScripts.length-1].src;
   //latest script file to be loaded i.e. this one!
   var slashPos = myPath.lastIndexOf("/");
   var backPos = myPath.lastIndexOf("\\");
   if (slashPos < backPos) slashPos = backPos;
   var wRelDir = "";
   if (slashPos > -1)
      wRelDir = myPath.substr(0,slashPos+1);
//   wRelDir = '../Lib/';
   return wRelDir;
}
// ------------------------------------------------------------------
// returns the ASCII character corresponding to the decimal value
// ------------------------------------------------------------------
function toASCII(inDec)
{
   var hexDigits = new String("0123456789ABCDEF");
   var wDec = inDec;
   var hexStr = "";
   while (wDec > 0)
   {
      var wDigit = wDec % 16;
      wDec = (wDec - wDigit)/16;
      hexStr = hexDigits.charAt(wDigit) + hexStr;
   }
   return eval("'\\x" + hexStr +"'");
}
// ----------------------------------------------------------------------
// Insert special characters & symbols
// ----------------------------------------------------------------------
function xzSpeChar(inString)
{
   var wStr = new String(inString);
   wStr = wStr.replace("*$br.","<br/>");
   wStr = wStr.replace("*$","&");
   return zSpeChar(wStr);
}
// ----------------------------------------------------------------------
// Insert special characters & symbols
// ----------------------------------------------------------------------
function zSpeChar(inString)
{

   var wStr = new String(inString);

   // line breaks from a <pre> tag are represented by the x'0D' character, these must be
   // replaced by <br/> tags, because innerHTML replaces them with spaces
   var posx; // position of x'0D' in hex table, as determined here:
   for (posx = 0;
      posx < 256 && (gHexTable.charArr[posx][1] != "0" || gHexTable.charArr[posx][2] != "D");
      posx++);
   wStr = wStr.replace(gHexTable.charArr[posx][0],"<br/>");
   // at this stage we don't want innerHTML to mess about removing spaces either
   //wStr = wStr.replace("  ", "&nbsp; ");
   // replace brackets in string
   wStr = wStr.replace(mathSymbol.TEMP_OPEN, "{");
   wStr = wStr.replace(mathSymbol.TEMP_CLOSE, "}");
   var ix = 0;
   while (ix < wStr.length)
   {
      if (wStr.charAt(ix) == "&")
      {
         jx = wStr.indexOf(".",ix);
         kx = wStr.indexOf(";",ix);
         if (jx == -1)
         // no closing period => no more abbreviations
         {
            ix = wStr.length + 1; // stops the 'while'-loop
         }
         else if (kx != -1 && kx < jx)
         // this is a HTML symbol: ignore an move on
         {
            ix = kx;
         }
         else
         {
            wStart  = new String(wStr.substr(0,ix));               // the bit before the &
            wSearch = new String(wStr.substr(ix + 1,jx - ix - 1)); // the bit between the & and the "."
            wEnd    = new String(wStr.substr(jx + 1));             // the bit after the "."
            var wx = gSymbolDict.locate(wSearch);
            if (wx == -1) // symbol not in dictionary - try HTML abbreviation
            {

               wStr = wStart + "&" + wSearch + ";" + wEnd;
               ix = jx; // move on to end of abbreviation
            }
            else // do the replacement
            {
               wStr = wStart + gSymbolDict.getSymbol(wx) + wEnd;
               // note ix stays where it is, there might be abbreviations in the replacement
            }
         }
      }
      else
         ix++;
   }
   return wStr;
}
// ----------------------------------------------------------------------





// ----------------------------------------------------------------------
// Insert special characters & symbols
// ----------------------------------------------------------------------
function xzSpeCharDom(inString)
{
   var wStr = new String(inString);
   wStr = wStr.replace("*$nbsp.","  ");
   wStr = wStr.replace("*$","&");

   var thisNode = document.createElement('span');
   thisNode.appendChild(zSpeCharDom(wStr));

   return thisNode;
}
// ----------------------------------------------------------------------
// Insert special characters & symbols
// ----------------------------------------------------------------------
function zSpeCharDom(inString)
{

   var parNode = document.createElement('span');

   var wStr = new String(inString);

//   // line breaks from a <pre> tag are represented by the x'0D' character, these must be
//   // replaced by <br/> tags, because innerHTML replaces them with spaces
//   var posx; // position of x'0D' in hex table, as determined here:
//   for (posx = 0;
//      posx < 256 && (gHexTable.charArr[posx][1] != "0" || gHexTable.charArr[posx][2] != "D");
//      posx++);
//   wStr = wStr.replace(gHexTable.charArr[posx][0],"<br/>");
//
//   // at this stage we don't want innerHTML to mess about removing spaces either
//   //wStr = wStr.replace("  ", "&nbsp; ");

   // replace brackets in string
   wStr = wStr.replace(mathSymbol.TEMP_OPEN, "{");
   wStr = wStr.replace(mathSymbol.TEMP_CLOSE, "}");

   var ix = wStr.indexOf("&");
   while (ix > -1)
   {
      jx = wStr.indexOf(".",ix);
      if (jx == -1)
         jx = wStr.indexOf(";",ix);
      if (jx == -1)
      // no closing period or colon => no more abbreviations
         ix = -1; // exits the 'while'-loop
      else
      {
         wStart  = new String(wStr.substr(0,ix));               // the bit before the &
         wSearch = new String(wStr.substr(ix + 1,jx - ix - 1)); // the bit between the & and the "."
         wEnd    = new String(wStr.substr(jx + 1));             // the bit after the "."
         var wx = gSymbolDict.locate(wSearch);
         if (wSearch == "br")
         {
            parNode.appendChild(document.createTextNode(wStart));
            parNode.appendChild(document.createElement('br'));
         }
         else if (wx == -1) // symbol not in dictionary - try HTML abbreviation
         {
            parNode.appendChild(document.createTextNode(wStart + "&" + wSearch + ";"));
         }
         else // do the replacement
         {
            parNode.appendChild(document.createTextNode(wStart));
            parNode.appendChild(gSymbolDict.getSymbol(wx));
         }
         wStr = wEnd;
         ix = wStr.indexOf("&");
      }
   }
   if (wStr.length > 0)
      parNode.appendChild(document.createTextNode(wStr));
   return parNode;

}

// ----------------------------------------------------------------------
function zCompileDoc()
{
  var wString = "";
  var ix = 0;
  while (wString.indexOf("<HTML") < 0)
     wString = document.all[ix++].outerHTML;


  // remove all scripts
  var startpos = wString.indexOf ("<SCRIPT");
  var endpos;
  while (startpos > -1)
  {
     endpos = wString.indexOf("</SCRIPT>") + 9;
     wString = wString.substr(0,startpos) + wString.substr(endpos);
     startpos = wString.indexOf ("<SCRIPT");
  }

  // remove Compiler button
  var ipos = wString.indexOf ("MWComp");
  var tString = wString.substr(0,ipos);
  var jpos = wString.indexOf ("</FORM>",ipos);
  ipos = tString.lastIndexOf("<FORM");
  wString = tString.substr(0,ipos) +  wString.substr(jpos + 7);

  // remove translateDoc call
  wString = wString.replace(" onload=translateDoc()","");
  // change style sheet
  wString = wString.replace("href=\"MathStyle.css\"","href=\"MathStylePrint.css\"");

  newWin = window.open("", "", "");
  newWin.document.write (wString);
  newWin.document.close();
}
// ------------------------------------------------------------------
function openXMLhttp (iInputFile)
{
   var xmlDoc = null;
   if (window.XMLHttpRequest)
   {
      //alert ("window.XMLHttpRequest");
      var xmlLink = new window.XMLHttpRequest();
      if (xmlLink.open)
         xmlLink.open("GET",iInputFile,false);
      try { xmlLink.send(); }
      catch(err2)
      {
         alert (iInputFile + " - xmlLink.send failed: " + err2);
         alert ("xmlLink " +
            " status: " + xmlLink.status +
            " readyState: " + xmlLink.readyState +
            " statusText: " + xmlLink.statusText +
            "");
      }
      xmlDoc = xmlLink.responseXML;
   }
   else if (ActiveXObject)
   {
      //alert ("ActiveXObject")
      //alert (iInputFile);
      xmlDoc = new ActiveXObject("Microsoft.XMLDOM")
      xmlDoc.async="false";
      xmlDoc.load(iInputFile);
   }
   else
   {
      alert ("cannot load XML document");
      return;
   }
   return xmlDoc;
}
// ------------------------------------------------------------------
function addNavListener (elem,evType,func)
{
   if (elem.addEventListener)
      elem.addEventListener(evType,func,false);
   else if (elem.attachEvent)
      elem.attachEvent('on' + evType,func);
   else
      elem['on' + evType] = func;
}

