// ==================================================================
// NOTE: the following variable defines the JAVA class path
   var wClassPathRelDir = getRelDir();

// ==================================================================
// Colour definitions
// ==================================================================
var RED     = "180|000|000|";
var BLUE    = "000|000|180|";
var GREEN   = "000|144|000|";
var ORANGE  = "255|100|000|";
var YELLOW  = "196|196|000|";
var VIOLET  = "144|000|144|";
var CYAN    = "000|144|144|";
var GREY    = "100|100|100|";
var BLACK   = "000|000|000|";
var WHITE   = "255|255|255|";

var gColours;

function zResetColours()
{
   gColours = new Array (BLUE, RED, GREEN,
      VIOLET, ORANGE, YELLOW, 
      CYAN, BLACK, BLUE, RED);
}

zResetColours();

var DrawingSuffix = new String("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ");

// ==================================================================
// Class: cGraph
//   The graph consists of the sheet of "graph paper" and a number
//   of drawings (objects) on that "sheet"
// ==================================================================
function cGraph (iWidth, iHeight) //*** class definition ***
{
// variables to control output (development/normal)
   this.wDevMode = false;
   this.lBrk = "<";
   this.rBrk = ">";
   this.linBreak = "";
   this.appletWidth = 360;
   this.appletHeight = 360;
   this.xRangeSet = false;
   this.xMin = -1;
   this.xMax = 1;
   this.yMin = isNaN;
   this.yMax = isNaN;
   this.mesh = isNaN;
   this.drawingIndex = 0;
   this.colourIndex = 0;
   this.text = new Array();
   this.textX = new Array();
   this.textY = new Array();
   this.yStretch = isNaN;
   this.yGridSuppress = false;
   this.points = 100;
   this.colours = new Array ();
   this.drawing = new Array ();
   this.xTitle = "";
   this.yTitle = "";
   this.error = false;

// --- Methods ----------------------------
   this.init         = cGraph_init; //for compatibility purposes only
   this.setWindow    = cGraph_setWindow;
   this.printGraph   = cGraph_print;
   this.print        = cGraph_print;
   this.writeParam   = cGraph_writeParam;
   this.setDevMode   = cGraph_setDevMode;
   this.setColours   = cGraph_setColours;
   this.setColors    = cGraph_setColours;
   this.setYstretch  = cGraph_setYstretch;
   this.suppressYgrid = cGraph_suppressYgrid
   this.setXrange    = cGraph_setXrange;
   this.setYrange    = cGraph_setYrange;
   this.setXgrid     = cGraph_setMesh;
   this.setMesh      = cGraph_setMesh;
   this.setPoints    = cGraph_setPoints;
   this.setXtitle    = cGraph_setXtitle;
   this.setYtitle    = cGraph_setYtitle;
   this.drawText     = cGraph_drawText;
   this.printInWindow = cGraph_printInWindow;
// --- drawing types
   this.initDraw     = cGraph_initDraw;
   this.drawPolygon  = cGraph_drawPolygon;
   this.drawFunction = cGraph_drawFunction;
   this.drawCurve    = cGraph_drawCurve;
   this.drawPointStep = cGraph_drawPointStep;
   this.drawStep     = cGraph_drawStep;
   this.drawScatter  = cGraph_drawScatter;
   this.drawPin      = cGraph_drawPin;
   this.drawArrow    = cGraph_drawArrow;
   this.drawLine     = cGraph_drawLine;
   this.drawCircle   = cGraph_drawCircle
// --- supplement drawing
   this.addLabel     = cGraph_addLabel;
   this.addShade     = cGraph_addShade;

// Constructor
 //  alert("cGraph constructor");
   if (iWidth != undefined)
      this.appletWidth = iWidth;
   if (iHeight != undefined)
      this.appletHeight = iHeight;
   else
      this.appletHeight = this.appletWidth;
//   for (var colIx = 0; colIx < gColours.length ; colIx++)
//      this.colours[colIx]  = gColours[colIx];
      this.colours  = gColours;

}
// ------------------------------------------------------------------
// This method reinitializes the graph
// THIS METHOD IS ONLY REQUIRED FOR COMPATIBILITY WITH VERSION 1
// ------------------------------------------------------------------
function cGraph_init()
{
   this.xMin = isNaN;
   this.xMax = isNaN;
   this.yMin = isNaN;
   this.yMax = isNaN;
   this.mesh = isNaN;
   this.drawingIndex = 0;
   this.colourIndex = 0;
   this.text = new Array();
   this.textX = new Array();
   this.textY = new Array();
   this.drawing = new Array();
//   this.colours = new Array ();
//   for (var colIx = 0; colIx < gColours.length ; colIx++)
//      this.colours[colIx]  = gColours[colIx];
//      this.colours  = gColours;
}
// ------------------------------------------------------------------
// sets the applet window width and height
// ------------------------------------------------------------------
function cGraph_setWindow(iWidth, iHeight)
{
   if (iWidth != undefined)
      this.appletWidth = iWidth;
   if (iHeight != undefined)
      this.appletHeight = iHeight;
   else
      this.appletHeight = this.appletWidth;
}
// ------------------------------------------------------------------
//  sets min and max x
// ------------------------------------------------------------------
function cGraph_setXrange ( iMinX, iMaxX )
{
   this.xMin = iMinX;
   this.xMax = iMaxX;
   this.xRangeSet = true;
}
// ------------------------------------------------------------------
//  sets min and max y
// ------------------------------------------------------------------
function cGraph_setYrange ( iMinY, iMaxY )
{
   this.yMin = iMinY;
   this.yMax = iMaxY;
}
// ------------------------------------------------------------------
//  sets mesh (of grid)
// ------------------------------------------------------------------
function cGraph_setMesh ( iMesh )
{
   this.mesh = iMesh;
}
// ------------------------------------------------------------------
//  sets number of points (resolution) for functions and curves
// ------------------------------------------------------------------
function cGraph_setPoints (iPoints)
{
//    alert ("set points " + iPoints);
   this.points = iPoints;
}
// ------------------------------------------------------------------
// Write the HTML
// ------------------------------------------------------------------
function cGraph_print (myWin)
{
   if (myWin == undefined) myWin = window;
   if (this.error) return;
   if (this.wDevMode)
   {
      this.lBrk = "&lt;";
      this.rBrk = "&gt;";
      this.linBreak = "<br />";
   }
   else
   {
      this.lBrk = "<";
      this.rBrk = ">";
      this.linBreak = "";
   }

   this.drawingIndex = 0;
/* */
   myWin.document.write(this.linBreak + this.lBrk +
      "applet code=\"DrawGraph.class\" " +
      "codebase=\"" + wClassPathRelDir + "\" " +
      "width=" + this.appletWidth +
      " height=" + this.appletHeight + this.rBrk );
/* */
/*  /
// -- new proposed syntaxt - doesn't work in IE6 /
   myWin.document.write(this.linBreak + this.lBrk +
      "object codetype=\"application/java\" " +
      "classid=\"java:DrawGraph.class\" " +
      "codebase=\"" + wClassPathRelDir + "\" " +
      "width=" + this.appletWidth +
      " height=" + this.appletHeight + this.rBrk );
/* */
   for (var ix = 0; ix < this.drawing.length; ix++)
      this.drawing[ix].print(myWin);

   for (var ix = 0; ix < this.text.length; ix++)
   {
      var wSuff = DrawingSuffix.charAt(ix);
      this.writeParam (myWin, "Text" + wSuff, this.text[ix]);
      this.writeParam (myWin, "TextX" + wSuff, this.textX[ix]);
      this.writeParam (myWin, "TextY" + wSuff, this.textY[ix]);
   }

   myWin.document.write(this.linBreak);
   if (!this.xRangeSet)
   {
      this.xMin = this.drawing[0].xMin;
      this.xMax = this.drawing[0].xMax;
      for (var ix = 1; ix < this.drawing.length; ix++)
      {
         if (this.xMin > this.drawing[ix].xMin)
            this.xMin = this.drawing[ix].xMin;
         if (this.xMax < this.drawing[ix].xMax)
            this.xMax = this.drawing[ix].xMax;
      }
   }
   if (this.yMin == isNaN || this.yMax == isNaN)
   {
      this.yMin = this.drawing[0].yMin;
      this.yMax = this.drawing[0].yMax;
      for (var ix = 1; ix < this.drawing.length; ix++)
      {
         if (this.yMin > this.drawing[ix].yMin)
            this.yMin = this.drawing[ix].yMin;
         if (this.yMax < this.drawing[ix].yMax)
            this.yMax = this.drawing[ix].yMax;
      }
   }
   if (this.yMin == isNaN) this.yMin = -1;
   if (this.yMax == isNaN) this.yMax = 1;

   if (this.mesh == isNaN)
   {
      var xRange = (this.xMax - this.xMin)/1.75;
      var xLog = Math.log(xRange)/Math.log(10);
      var xExp = (xLog>0?Math.floor(xLog):Math.ceil(xLog));
      this.mesh = Math.pow(10,xExp);
   }
   if (this.yStretch == isNaN)
   {
      this.yStretch = (this.xMax - this.xMin)* this.appletHeight
         / ((this.yMax - this.yMin) * this.appletWidth);
      if (this.yStretch < 1)
         this.yStretch = 1/(roundUpSF(1/this.yStretch,1));
      else
         this.yStretch = roundSF(this.yStretch,1);
   }
   this.writeParam (myWin, "xMin", this.xMin - .001 );
   this.writeParam (myWin, "xMax", this.xMax);
   this.writeParam (myWin, "Mesh", this.mesh);
   this.writeParam (myWin, "Ystretch", this.yStretch);
   this.writeParam (myWin, "yMin", this.yMin);
   this.writeParam (myWin, "yMax", this.yMax);
   this.writeParam (myWin, "xTitle", this.xTitle);
   this.writeParam (myWin, "yTitle", this.yTitle);
   if (this.yGridSuppress)
      this.writeParam (myWin, "yGridSuppress", "TRUE");
   else
      this.writeParam (myWin, "yGridSuppress", "FALSE");

   myWin.document.write(this.linBreak + this.lBrk + "/applet" + this.rBrk );

//   myWin.document.write(this.linBreak + this.lBrk + "/object" + this.rBrk );

}
// ------------------------------------------------------------------
// set the development mode flag (displays HTML instead of graph) ----
// ------------------------------------------------------------------
function cGraph_setDevMode(iDevMode)
{
   this.wDevMode = iDevMode;
   if (this.wDevMode)
   {
      this.lBrk = "&lt;";
      this.rBrk = "&gt;";
      this.linBreak = "<br />";
   }
   else
   {
      this.lBrk = "<";
      this.rBrk = ">";
      this.linBreak = "";
   }
}
// ------------------------------------------------------------------
// write the applet parameter ------------------------------
// ------------------------------------------------------------------
function cGraph_writeParam (myWin, iName, iValue)
{
   myWin.document.write(this.linBreak + this.lBrk + "param name=\"" + iName +
      "\" value=\"" + iValue + "\" /" + this.rBrk );
}
// ------------------------------------------------------------------
// set the colour palette  ----
// ------------------------------------------------------------------
function cGraph_setColours(iColours)
{
   if (iColours == undefined)
      this.colours  = gColours;
   else
   {
      try
      {
         eval("this.colours = new Array(" + iColours.toUpperCase() + ")");
      }
      catch (errVal)
      {
         alert("Problem setting colours:\n\n" + iColours);
      }
   }
}
// ------------------------------------------------------------------
// set the stretching factor of the y-axis
// ------------------------------------------------------------------
function cGraph_setYstretch(iStretch)
{
   if (iStretch == undefined) iStretch = 1;
   this.yStretch = iStretch;
}
// ------------------------------------------------------------------
// set indicator to suppress print of y-grid
// ------------------------------------------------------------------
function cGraph_suppressYgrid()
{
   this.yGridSuppress =  true;
}
// ------------------------------------------------------------------
// initializes a new drawing on the graph ----
// ------------------------------------------------------------------
function cGraph_initDraw (iType)
{
    var wColour;
    var wDrawIx = this.drawing.length;
//    if (wDrawIx < this.colours.length)
//       wColour = this.colours[wDrawIx];
//    else
//       wColour =  GREY;
    var wDraw = new cDrawing(this, iType);
    this.drawing [wDrawIx] = wDraw;
    return wDraw;
}
// ------------------------------------------------------------------
// draw a polygon between the given points ----
// ------------------------------------------------------------------
function cGraph_drawPolygon (iCoords, iClosed)
{
    var wDraw = this.initDraw("polygon");
    wDraw.setPoints (iCoords, iClosed);
    return wDraw;
}
// ------------------------------------------------------------------
// draw graph of y as a Function of x ----
// ------------------------------------------------------------------
function cGraph_drawFunction (iFunc, xFrom, xTo, iPoints)
{
    var wDraw = this.initDraw("function");
    wDraw.calcFunction (iFunc, xFrom, xTo, iPoints);
    return wDraw;
}
// ------------------------------------------------------------------
// draw (parametric) curve of x and y as functions of t  ----
// ------------------------------------------------------------------

function cGraph_drawCurve (xFunc, yFunc, tFrom, tTo, iPoints)
{
    var wDraw = this.initDraw("curve");
    wDraw.calcCurve (xFunc, yFunc, tFrom, tTo, iPoints);
    return wDraw;
}
// ------------------------------------------------------------------
// draw step diagram of y as functions of x  ----
// ------------------------------------------------------------------
function cGraph_drawStep (iFunc, iStep, iType, xFrom, xTo)
{
    var wDraw = this.initDraw("step");
    wDraw.calcStep(iFunc, iStep, iType, xFrom, xTo) ;
    return wDraw;
}
// ------------------------------------------------------------------
// draw step diagram of the given points  ----
// ------------------------------------------------------------------
function cGraph_drawPointStep (iCoords)
{
    var wDraw = this.initDraw("step");
    wDraw.setPoints (iCoords, false);
    return wDraw;
}
// ------------------------------------------------------------------
// draw a set of scatter points
// ------------------------------------------------------------------
function cGraph_drawScatter (iCoords)
{
    var wDraw = this.initDraw("scatter");
    wDraw.setPoints (iCoords, false);
    return wDraw;
}
// ------------------------------------------------------------------
// draw a set of pins (from x-axis)
// ------------------------------------------------------------------
function cGraph_drawPin (iCoords)
{
    var wDraw = this.initDraw("pin");
    wDraw.setPoints (iCoords, false);
    return wDraw;
}
// ------------------------------------------------------------------
// draw a line on the graph
// ------------------------------------------------------------------
function cGraph_drawLine(X1,Y1,X2,Y2)
{
  var coords = X1 + "," + Y1 + "," + X2 + "," + Y2 ;
  this.drawPolygon(coords,false);
}
// ------------------------------------------------------------------
// draw a circle on the graph
// ------------------------------------------------------------------
function cGraph_drawCircle(cenX,cenY,rad)
{
  var xFunc = cenX + "+" + rad + "*cos(t)" ;
  var yFunc = cenY + "+" + rad + "*sin(t)" ;
  this.drawCurve(xFunc, yFunc, 0, 2*Math.PI);
}
// ------------------------------------------------------------------
// ---- Draw an arrow on the Graph ----
// ------------------------------------------------------------------
function cGraph_drawArrow(X1,Y1,X2,Y2,iHead)
{
  var wHead;
  if (iHead == undefined ) wHead = 1;
  else wHead = iHead;
  var prop = wHead/Math.sqrt((X2 - X1)*(X2 - X1) + (Y2 - Y1)*(Y2 - Y1));
  var tanA = 0.3;
  var X0 = ((prop) * X1) + ((1-prop) * X2);
  var Y0 = ((prop) * Y1) + ((1-prop) * Y2);
  var coords = X1 + "," + Y1 + "," + X2 + "," + Y2;
  var X3 = X0 - ((Y2-Y0)*tanA);
  var Y3 = Y0 + ((X2-X0)*tanA);
  var X4 = X0 + ((Y2-Y0)*tanA);
  var Y4 = Y0 - ((X2-X0)*tanA);
  var coords = X3 + "," + Y3 + "," + X2 + "," + Y2 + "," + X1 + "," + Y1 + "," + X2 + "," + Y2 + "," + X4 + "," + Y4;
  this.drawPolygon(coords,false);
}
// ------------------------------------------------------------------
// ---- Draw text on the Graph ----
// ------------------------------------------------------------------
function cGraph_drawText (iText,iXcoord,iYcoord)
{
   textIndex = this.text.length;
   this.text [textIndex] = iText;
   this.textX [textIndex] =  iXcoord;
   this.textY [textIndex] =  iYcoord;
}
// ------------------------------------------------------------------
//  sets title of the x-axis
// ------------------------------------------------------------------
function cGraph_setXtitle (iText)
{
   this.xTitle = iText;
}
// ------------------------------------------------------------------
//  sets the title of the y-axis
// ------------------------------------------------------------------
function cGraph_setYtitle (iText)
{
   this.yTitle = iText;
}
// ------------------------------------------------------------------
// adds a label (with position) for the last defined drawing
// ------------------------------------------------------------------
function cGraph_addLabel (iText, iLabelX , iLabelY)
{
  this.drawing[this.drawing.length - 1].addLabel (iText, iLabelX , iLabelY);
}
// ------------------------------------------------------------------
// adds shade to the last defined drawing
// ------------------------------------------------------------------
function cGraph_addShade (xFrom, xTo)
{
  this.drawing[this.drawing.length - 1].addShade (xFrom, xTo);
}
// ==================================================================
// Class: cDrawing
// ==================================================================
function cDrawing (iGraph, iType) //*** class definition ***
{
// General attributes
   this.graph = iGraph; // the sheet on which the drawing will be
   this.drawingType = iType;
   this.JavaDrawType = "";
   this.drawingIndex = this.graph.drawingIndex++;
   this.xVals = "";
   this.yVals = "";
   this.xMin = isNaN;
   this.xMax = isNaN;
   this.yMin = isNaN;
   this.yMax = isNaN;
   this.label = "";
   this.labelX = 0;
   this.labelY = 0;
   this.shadeMin = new Array;
   this.shadeMax = new Array;
// Attributes for functions and curves
   this.yFunc;
   this.xFunc;
   this.parmIncr;
   this.points;
// Attributes for step functions
   this.stepType;

// Methods
   this.setPoints         = cDrawing_setPoints;
   this.calcFunction      = cDrawing_calcFunction;
   this.genFuncPoint      = cDrawing_genFuncPoint;
   this.calcCurve          = cDrawing_calcCurve;
   this.genCurvePoint     = cDrawing_genCurvePoint;
   this.print             = cDrawing_print;
   this.subsMath          = cDrawing_subsMath;
   this.calcStep          = cDrawing_calcStep;
   this.addLabel          = cDrawing_addLabel;
   this.addShade          = cDrawing_addShade;
   this.printShade        = cDrawing_printShade;

   if (this.drawingType == "step")
      this.JavaDrawType = "step";
   else if (this.drawingType == "scatter")
      this.JavaDrawType = "scatter";
   else if (this.drawingType == "pin")
      this.JavaDrawType = "pin";
   else
      this.JavaDrawType = "graph";

}
// ------------------------------------------------------------------
// set the points of the polygon
// ------------------------------------------------------------------
function cDrawing_setPoints(iCoords, iClosed)
{
   var parms = iCoords.split(",");

   var x = Number(parms[0]);
   var y = Number(parms[1]);
   this.xMax = this.xMin = x;
   this.yMax = this.yMin = y;
   this.xVals +=  formatDP(x,4) +  "|";
   this.yVals +=  formatDP(y,4) +  "|";
   for (var ix = 3; ix < parms.length; ix +=2)
   {
      x = Number(parms[ix - 1]);
      y = Number(parms[ix]);
      if (x < this.xMin) this.xMin = x;
      if (x > this.xMax) this.xMax = x;
      if (y < this.yMin) this.yMin = y;
      if (y > this.yMax) this.yMax = y;
      this.xVals +=  formatDP(x,4) +  "|";
      this.yVals +=  formatDP(y,4) +  "|";
   }
   if (this.drawingType == "pin")
   {
      if (this.yMin > 0) this.yMin=0;
      if (this.yMax < 0) this.yMax=0;
   }
   if ((iClosed == true) && (parms.length > 1))
   {
      x = Number(parms[0]);
      y = Number(parms[1]);
      this.xVals +=  formatDP(x,4) +  "|";
      this.yVals +=  formatDP(y,4) +  "|";
   }
}
// ------------------------------------------------------------------
// calculate points for graph of y as a Function of x.
// ------------------------------------------------------------------
function cDrawing_calcFunction (iFunc, xFrom, xTo, iPoints)
{
   if (xFrom == undefined) this.xMin = this.graph.xMin;
   else this.xMin = xFrom;
   if (xTo == undefined)   this.xMax = this.graph.xMax;
   else this.xMax = xTo;
   this.yFunc = this.subsMath(iFunc)

   // --- set initial min and max y to the first value ---
   var x = this.xMin;
   if (zDoEval(this.yFunc, x)) //checks that the eval will work
      this.yMin = eval(this.func);
   else
   {
      this.graph.error = true;
      return;
      this.yMin = 0;
   }
   var x = this.xMax;
   if (zDoEval(this.yFunc, x)) //checks that the eval will work
      this.yMax = eval(this.yFunc);
   else
      this.yMax = 0;
   if (this.yMin > this.yMax)
   {
      var wTemp = this.yMin;
      this.yMin = this.yMax;
      this.yMax = wTemp;
   }
   // --- determine number of points and resulting increment
   if (iPoints == undefined)
      this.points = this.graph.points;
   else this.points = iPoints;
   this.parmIncr = (this.xMax - this.xMin)/(this.points);
   // --- generate the points ---
   this.xVals = "";
   this.yVals = "";
   var xCoord = this.xMin;
   if (zDoEval(this.yFunc, xCoord)) //checks that the eval will work
   {
      while( xCoord < this.xMax)
      {
         this.genFuncPoint (xCoord, this.xMin, this.xMax)
         xCoord += this.parmIncr;
      }
      // --- The (ight-hand) end point: ---
      xCoord = this.xMax;
      this.genFuncPoint (xCoord)
   }
}
// ------------------------------------------------------------------
// generate the individual points for a Function
// ------------------------------------------------------------------
function cDrawing_genFuncPoint (xCoord)
{
   var x;
   var y;
   if (xCoord > Number(this.xMin) - this.parmIncr && xCoord <= Number(this.xMax))
   {
      if (this.JavaDrawType == "step" && this.stepType == "on")
      {
         x = xCoord + (this.parmIncr/2);
         y = eval (this.yFunc);
      }
      else if (this.JavaDrawType == "step")
      {
         x = xCoord;
         var y1 = eval (this.yFunc);
         x = xCoord + (this.parmIncr);
         var y2 = eval (this.yFunc);
         if (this.stepType == "below")
            y = Math.min(y1,y2);
         else
            y = Math.max(y1,y2);
      }
      else
      {
         x = xCoord;
         y = eval (this.yFunc);
      }

      if ((!isNaN(y)) && y != "-Infinity" && y != "Infinity")
//      if (y < this.yMaxCap && y > this.yMinCap)
      {
         if ((y < this.yMin) || isNaN(this.yMin)) this.yMin = y;
         if ((y > this.yMax) || isNaN(this.yMax)) this.yMax = y;
         this.xVals +=  formatDP(xCoord,4) +  "| ";
         this.yVals +=  formatDP(y,4) +  "| ";
      }
   }
}
// ------------------------------------------------------------------
// calculate points for a parametric curve.
// ------------------------------------------------------------------
function cDrawing_calcCurve (xFunc, yFunc, tFrom, tTo, iPoints)
{
   var wtMin;
   var wtMax;
   if (tFrom == undefined) wtMin = 0; else wtMin = tFrom;
   if (tTo == undefined)   wtMax = 1; else wtMax = tTo;
   this.yFunc = this.subsMath(yFunc)
   this.xFunc = this.subsMath(xFunc)
   // --- determine number of points and resulting increment
   if (iPoints == undefined)
      this.points = this.graph.points;else this.points = iPoints;
   this.parmIncr = (wtMax - wtMin)/(this.points);

   // --- generate the points ---
   this.xVals = "";
   this.yVals = "";
   var tCoord = wtMin;
   if (zDoEval(this.yFunc, tCoord)&& zDoEval(this.xFunc, tCoord))
   //checks that the evals will work
   {
      var t = tCoord;
      var x = eval (this.xFunc);
      var y = eval (this.yFunc);
      this.xMin = this.xMax = x;
      this.yMin = this.yMax = y;

      while( tCoord < wtMax)
      {
         this.genCurvePoint (tCoord, wtMin, wtMax)
         tCoord += this.parmIncr;
      }
      // --- The (right-hand) end point: ---
      tCoord = wtMax;
      this.genCurvePoint (tCoord, wtMin, wtMax)
   }
}
// ------------------------------------------------------------------
// generate the individual points for a curve
// ------------------------------------------------------------------
function cDrawing_genCurvePoint (tCoord, tFrom, tTo)
{
   var t;
   var x;
   var y;
   if (tCoord > Number(tFrom) - this.parmIncr && tCoord <= Number(tTo))
   {
      t = tCoord;
      x = eval (this.xFunc);
      y = eval (this.yFunc);
      if (x < this.xMin) this.xMin = x;
      if (x > this.xMax) this.xMax = x;
      if (y < this.yMin) this.yMin = y;
      if (y > this.yMax) this.yMax = y;

      if   (((!isNaN(x)) && x != "-Infinity" && x != "Infinity")
         && ((!isNaN(y)) && y != "-Infinity" && y != "Infinity") )
      {
         this.xVals +=  formatDP(x,4) +  "| ";
         this.yVals +=  formatDP(y,4) +  "| ";
      }
   }
}
// ------------------------------------------------------------------
// calculate points for a step function.
// ------------------------------------------------------------------
function cDrawing_calcStep(iFunc, iStep, iType, xFrom, xTo)
{
   if (xFrom == undefined) this.xMin = this.graph.xMin;
   else this.xMin = xFrom;
   if (xTo == undefined)   this.xMax = this.graph.xMax;
   else this.xMax = xTo;
   this.yFunc = this.subsMath(iFunc)

   // --- set initial min and max y to the first value ---
   var x = this.xMin;
   if (zDoEval(this.yFunc, x)) //checks that the eval will work
      this.yMin = eval(this.func);
   else
      this.yMin = 0;
   var x = this.xMax;
   if (zDoEval(this.yFunc, x)) //checks that the eval will work
      this.yMax = eval(this.func);
   else
      this.yMax = 0;
   if (this.yMin > this.yMax)
   {
      var wTemp = this.yMin;
      this.yMin = this.yMax;
      this.yMax = wTemp;
   }

   if (iType == "below" || iType == "above")
      this.stepType = iType;
   else
      this.stepType = "on";
   this.parmIncr = iStep;

   // --- generate the points ---
   this.xVals = "";
   this.yVals = "";
   var xCoord = this.xMin;
   if (zDoEval(this.yFunc, xCoord)) //checks that the eval will work
   {
      while( xCoord < this.xMax)
      {
         this.genFuncPoint (xCoord, this.xMin, this.xMax)
         xCoord += this.parmIncr;
      }
      // --- The (right-hand) end point: ---
      xCoord = this.xMax;
      this.genFuncPoint (xCoord)
   }

}
// ------------------------------------------------------------------
// convert maths functions to JavaScript Math object functions
// ------------------------------------------------------------------
function cDrawing_subsMath (iFunc)
{
   var wMathFuncs = new Array ("PI","random","atan2","floor","round",
      "acos","asin","atan","ceil","sqrt","abs","sin","cos","tan",
      "exp","log","min","max","pow");
   var Ldelims = " +-*/()";
   var Rdelims = " (";
   var wFunc = iFunc;
   var wBegin;
   var wEnd;
   for (var ix = 0; ix < wMathFuncs.length; ix++)
   {
      wEnd = wFunc;
      wBegin = "";
      var wcut = wEnd.indexOf(wMathFuncs[ix]);
      while (wcut != -1)
      {
         var subsOK = true;
         if (wcut > 0)
            if (Ldelims.indexOf(wEnd.charAt(wcut-1)) == -1)
               subsOK = false;
         if (wcut + wMathFuncs[ix].length < wEnd.length)
            if (Rdelims.indexOf(wEnd.charAt(wcut + wMathFuncs[ix].length)) == -1)
               subsOK = false;
         if (subsOK == true)
            wBegin += wEnd.substring(0,wcut) + "Math." + wMathFuncs[ix];
         else
            wBegin += wEnd.substring(0,wcut) + wMathFuncs[ix];
         wEnd = wEnd.substring(wcut + wMathFuncs[ix].length);
         wcut = wEnd.indexOf(wMathFuncs[ix]);
      }
      wFunc = wBegin + wEnd;
   }
   return wFunc;
}
// ------------------------------------------------------------------
// defines the label (and position) for the curve
// ------------------------------------------------------------------
function cDrawing_addLabel (iText, iLabelX , iLabelY)
{
   this.label =  iText;
   this.labelX = iLabelX;
   this.labelY = iLabelY;
}
// ------------------------------------------------------------------
// defines an area of shade under the curve (functions and steps only)
// ------------------------------------------------------------------
function cDrawing_addShade (xFrom , xTo)
{
   if (this.drawingType == "function" || this.drawingType == "step")
   {
      var shadeIx = this.shadeMin.length;
      this.shadeMin [shadeIx] = xFrom;
      this.shadeMax [shadeIx] = xTo;
   }
}
// ------------------------------------------------------------------
// writes the HTML for the drawing
// ------------------------------------------------------------------
function cDrawing_print(myWin)
{
   myWin.document.write(this.graph.linBreak);
   var wDrawSuff = DrawingSuffix.charAt(this.graph.drawingIndex++);
   var wColour;
   if (this.graph.colours.length > this.drawingIndex)
      wColour = this.graph.colours[this.drawingIndex];
   else
      wColour = GREY;

   this.graph.writeParam (myWin, "Type"   + wDrawSuff, this.JavaDrawType);
   this.graph.writeParam (myWin, "Colour" + wDrawSuff, wColour);
   this.graph.writeParam (myWin, "xVals"  + wDrawSuff, this.xVals);
   this.graph.writeParam (myWin, "yVals"  + wDrawSuff, this.yVals);
   this.graph.writeParam (myWin, "Label"  + wDrawSuff, this.label);
   this.graph.writeParam (myWin, "LabelX" + wDrawSuff, this.labelX);
   this.graph.writeParam (myWin, "LabelY" + wDrawSuff, this.labelY);
   for (var ix = 0; ix < this.shadeMin.length; ix++)
      this.printShade (myWin, ix);
}
// ------------------------------------------------------------------
// writes HTML to print shade under the Function or step
// ------------------------------------------------------------------
function cDrawing_printShade (myWin, shadeIx)
{
   // alert ("this.shadeMin [" + shadeIx + "]: " + this.shadeMin [shadeIx] +
   //      "\nthis.shadeMax [" + shadeIx + "]: " + this.shadeMax [shadeIx]);
   myWin.document.write(this.graph.linBreak);
   var wDrawSuff = DrawingSuffix.charAt(this.graph.drawingIndex++);
   var wXvals = this.xVals.split ("|");
   var wYvals = this.yVals.split ("|");
   wXvals.pop();
   wYvals.pop();
   var xShadeVals = "";
   var yShadeVals = "";
   var ix;
   var jx;

   for (ix = 0; ix <  wXvals.length && this.shadeMin [shadeIx] >= wXvals [ix]; ix++);
   for (jx = (wXvals.length - 1) ; jx >= 0  && this.shadeMax [shadeIx] <= wXvals [jx]; jx--);

/* debug start /
   this.graph.writeParam (myWin, "wXvals.length" , wXvals.length);
   this.graph.writeParam (myWin, "this.shadeMin [shadeIx]" , this.shadeMin [shadeIx]);
   this.graph.writeParam (myWin, "this.shadeMax [shadeIx]" , this.shadeMax [shadeIx]);
   this.graph.writeParam (myWin, "ix" , ix);
   this.graph.writeParam (myWin, "jx" , jx);
   this.graph.writeParam (myWin, "wXvals [ix]" , wXvals [ix]);
   this.graph.writeParam (myWin, "wXvals [jx]" , wXvals [jx]);
/* debug end */

   // alert ("ix: " + ix +  "\njx: " + jx + "\nwXvals.length: " + wXvals.length);
   if (  (this.shadeMin [shadeIx] < this.shadeMax [shadeIx])
      && (ix <= wXvals.length - 1)
      && (jx >= 0))
   {
      if (ix > 0)
      {
         var wY;
         if (this.drawingType == "step")
            wY = Number(wYvals[ix-1]);
         else
         {
            var wY1 = Number(wYvals[ix]);
            var wY0 = Number(wYvals[ix-1]);
            var wX1 = Number(wXvals[ix]);
            var wX0 = Number(wXvals[ix-1]);
            wY = ( ( (wY1 - wY0) / (wX1 - wX0) )
                     * (this.shadeMin [shadeIx] - wX0) ) + wY0 ;
         }
         xShadeVals += this.shadeMin [shadeIx] + "|";
         yShadeVals += formatDP(wY,4) + "|";
      }

      for (var kx = ix; kx <= jx; kx++)
      {
         xShadeVals += wXvals [kx] + "|";
         yShadeVals += wYvals [kx] + "|";
      }

      if (jx < wXvals.length - 1)
      {
         var wY1 = Number(wYvals[jx]);
         var wY0 = Number(wYvals[jx+1]);
         var wX1 = Number(wXvals[jx]);
         var wX0 = Number(wXvals[jx+1]);
         var wY = ( ( (wY1 - wY0) / (wX1 - wX0) )
                  * (this.shadeMax [shadeIx] - wX0) ) + wY0 ;
         xShadeVals += this.shadeMax [shadeIx] + "|";
         yShadeVals += formatDP(wY,4) + "|";
      }
      // alert ( "xShadeVals: " + xShadeVals + "\nyShadeVals: " + xShadeVals );
      this.graph.writeParam (myWin, "Type"   + wDrawSuff, this.JavaDrawType + "Shade");
      this.graph.writeParam (myWin, "Colour" + wDrawSuff, this.graph.colours[this.drawingIndex]);
      this.graph.writeParam (myWin, "xVals"  + wDrawSuff, xShadeVals);
      this.graph.writeParam (myWin, "yVals"  + wDrawSuff, yShadeVals);
   }
}
// =================== generic functions ==========================
// ----------------------------------------------------------------
// evaluate Function with error trapping
// ----------------------------------------------------------------
function zDoEval(iFunc, iX)
{
   var x = iX;
   var t = iX;
   var wRet = false;
   try
   {
      eval (iFunc);
      wRet = true;
   }
   catch (errVal)
   {
      alert("syntaxt error in expression\n\n" + iFunc + "\n");
      wRet = false;
   }
   finally
   {
      return wRet;
   }
}
// ----------------------------------------------------------------
// round to wSF significant figures
// ----------------------------------------------------------------
function roundSF (iNum,wSF)
{
   var wSign = (iNum>0?1:-1);
   var wNum = (iNum>0?iNum:-1*iNum);
   var wEx = Math.floor(Math.log(wNum)/Math.log(10));
   var wResult = Math.floor(wNum * Math.pow(10,wSF-1-wEx))
      / Math.pow(10,wSF-1-wEx);
   return wSign*wResult;
}
// ----------------------------------------------------------------
// round up to wSF significant figures
// ----------------------------------------------------------------
function roundUpSF (iNum,wSF)
{
   var wSign = (iNum>0?1:-1);
   var wNum = (iNum>0?iNum:-1*iNum);
   var wEx = Math.floor(Math.log(wNum)/Math.log(10));
   var wResult = Math.ceil(wNum * Math.pow(10,wSF-1-wEx))
      / Math.pow(10,wSF-1-wEx);
   return wSign*wResult;
}
// ----------------------------------------------------------------
// format number to show wDP decimal places
// ----------------------------------------------------------------
function formatDP (iNum,wDP)
{
   var wNum;
   var strZeros = "00000000000000000000";
   if (wDP > 20)
      wDP = 20;
   if (iNum < 0)
      wNum = (1.0 * iNum) - (0.5 * Math.pow(10,-1 * wDP));
   else
      wNum = (1.0 * iNum) + (0.5 * Math.pow(10,-1 * wDP));
   var sNum = new String(wNum.toString());
   var ix = sNum.indexOf(".");
   if (ix < 0)
      sNum = sNum + "." + strZeros;
   else
      sNum = sNum + strZeros;
   ix = sNum.indexOf(".");
   sNum = sNum.substr(0,ix + wDP + 1);
   return sNum;
}
// ----- public functions -----------------------------------------------
zGraph = new cGraph();

function zInitGraph (iMinX, iMaxX, iMesh)
{
   // reuse zGraph object keeping width and height
   zGraph.init();
   zGraph.setXrange (iMinX, iMaxX);
   zGraph.setMesh (iMesh);
}

function zPrintGraph (){
   zGraph.print();}

function zSetDevMode (){
   zGraph.setDevMode(true);}

function zDrawPolygon (iCoords, iClosed){
   zGraph.drawPolygon (iCoords, iClosed);}

function zDrawGraph (iFunc, xFrom, xTo, iPoints){
   zGraph.drawFunction (iFunc, xFrom, xTo, iPoints);}

function zDrawCurve (xFunc, yFunc, tFrom, tTo, iPoints){
   zGraph.drawCurve (xFunc, yFunc, tFrom, tTo, iPoints);}

function zDrawStep (iFunc, iStep, iType, xFrom, xTo){
   if (iType == undefined) iType = "step";
   if (iType == "above" || iType == "below")
      zGraph.drawStep (iFunc, iStep, iType, xFrom, xTo);
   else
      zGraph.drawStep (iFunc, iStep, "on", xFrom, xTo);}

function zDrawPin (iCoords){
   zGraph.drawPin (iCoords);}

function zDrawScatter (iCoords){
   zGraph.drawScatter (iCoords);}

function zDrawXTitle (iText){
   zGraph.setXtitle (iText);}

function zDrawYTitle (iText){
   zGraph.setYtitle (iText);}

function zDrawLabel (iText, iXcoord, iYcoord){
   zGraph.addLabel (iText, iXcoord, iYcoord);}

function zDrawShade (iFromX, iToX){
   zGraph.addShade (iFromX, iToX);}

function zDrawText (iText, iXcoord, iYcoord){
   zGraph.drawText (iText, iXcoord, iYcoord);}

function cGraph_printInWindow(wText,wTitle)
{
   var myWin=window.open('','',
      "toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=yes",false);
   myWin.document.open("text/html","replace");

   myWin.document.write("<html><head><title>" + wTitle + "</title>" +
      "</head><body style=\";background-color:#abb\">");
   myWin.document.write("<div style=\"text-align:center\">");
   this.print(myWin);
   if (wText != undefined)
      myWin.document.write("<br />" + wText);
   if (wTitle != undefined)
      myWin.document.write("<p>" + wTitle+ "</p>");
   myWin.document.write("<br /><form><input type='button' value='Close Window' " +
      "onClick=\"window.close()\"></form>");
   myWin.document.write("</div></body></html>");
   return myWin;
}
// ------------------------------------------------------------------
// returns the relative path from the document to this script file
// this module must be called on load of the script file.
// ------------------------------------------------------------------
function getRelDir()
{
   var docScripts = document.getElementsByTagName("script");
   var myPath = docScripts[docScripts.length-1].src;
   //latest script file to be loaded i.e. this one!
   var slashPos = myPath.lastIndexOf("/");
   var backPos = myPath.lastIndexOf("\\");
   if (slashPos < backPos) slashPos = backPos;
   var wRelDir = "";
   if (slashPos > -1)
      wRelDir = myPath.substr(0,slashPos+1);
   return wRelDir;
}

