   var gObjNo = 1;
   var wMathymaLib = getRelDir();
// ------------------------------------------------------------------
// returns the relative path from the document to this script file
// this module must be called on load of the script file.
// ------------------------------------------------------------------
function getRelDir()
{
   var myPath = document.scripts(document.scripts.length-1).src;
   //latest script file to be loaded i.e. this one!
   var slashPos = myPath.lastIndexOf("/");
   var backPos = myPath.lastIndexOf("\\");
   if (slashPos < backPos) slashPos = backPos;
   var wRelDir = "";
   if (slashPos > -1)
      wRelDir = myPath.substr(0,slashPos+1);
   return wRelDir;
}
// ------------------------------------------------------------------------
// xml file of distribution definitions
// ------------------------------------------------------------------------
var xmlDoc;
function loadDist()
{
//  alert("loading........");
  try //Internet Explorer
     {xmlDoc=new ActiveXObject("Microsoft.XMLDOM");}
  catch(e)
  {
    try //Firefox, Mozilla, Opera, etc.
       {xmlDoc=document.implementation.createDocument("","",null);}
    catch(e)
    {
      alert(e.message);
      return;
    }
  }
  xmlDoc.async=false;
  var iInputFile = wMathymaLib + "MathymaStatDistr.xml";
  xmlDoc.load(iInputFile);
}

// ------------------------------------------------------------------------
// cDistribution class
// ------------------------------------------------------------------------
function cDistribution(wId)
{
// * attributes

   this.DistId = wId.toUpperCase(); // unique id.

   this.Type;
   this.discrete = false;
   this.continuous;

   this.Name;  // for display purposes
   this.Eqn;  // equation of density function in MathCaster format
   this.DensFunc; // name of density func for eval in MathCasterGraph (no args) - [string]
   this.Range;   // x range for graph
   this.Start;  // x start for graph
   this.Xmax;  // point of maximum density
   this.DistFunc; // name of distribution function for calculation
   this.InvFunc; // name of inverse distribution function for calculation
   this.MirrFunc; // name of function to get cut-off point for opposite tail

   this.TwoTailed = false; // allow button to draw two tail SP on
   this.Reference = "Obj" + (gObjNo++); // links distribution object to form (and vice-versa)

   this.ParmLead = new Array(); // array of parameter text lead
   this.ParmDefault = new Array();   // array of parameter default value for form

   this.ErrorCond = new Array(); // table of error conditions (evals)
   this.ErrorMsg = new Array();  // table of corresponding messages

   // give the name defined in reference to this cDistribution object
   // so that it can be referred to from the form
   eval (this.Reference + " = this");

// * methods
   this.Build          = cDistribution_Build;
   this.DefineError    = cDistribution_DefineError;
   this.DrawForm       = cDistribution_DrawForm;
   this.Display        = cDistribution_Display;
   this.CalcInvFunc    = cDistribution_CalcInvFunc;
   this.CalcDistFunc   = cDistribution_CalcDistFunc;
   this.CalcMirrFunc   = cDistribution_CalcMirrFunc;
   this.BuildFunc      = cDistribution_BuildFunc;
   this.TestDisplay    = cDistribution_TestDisplay;

   this.Build();
}
// ------------------------------------------------------------------------
// Define error condition and resulting message
// ------------------------------------------------------------------------
function cDistribution_Build()
{
   if (!xmlDoc)
     loadDist();
   var wDistTag=xmlDoc.getElementsByTagName("Distribution");
   var ix = -1;
   for (var wix=0; wix < wDistTag.length && ix < 0; wix++)
   {
       var wNodeId = wDistTag[wix].getElementsByTagName('Id')[0].childNodes[0].nodeValue.toUpperCase();
       if (wNodeId.indexOf(this.DistId) == 0 )
          ix = wix;
   }
   if (ix < 0)
      alert ("There is no distribution with id. \"" + this.DistId + "\"");
   else
   {
      var wPtr;
      wPtr = wDistTag[ix].getElementsByTagName('Type')[0];
      if (wPtr != undefined) this.Type = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('Name')[0];
      if (wPtr != undefined) this.Name = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('Eqn')[0];
      if (wPtr != undefined) this.Eqn = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('DensFunc')[0];
      if (wPtr != undefined) this.DensFunc = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('Range')[0];
      if (wPtr != undefined) this.Range = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('Start')[0];
      if (wPtr != undefined) this.Start = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('Xmax')[0];
      if (wPtr != undefined) this.Xmax = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('DistFunc')[0];
      if (wPtr != undefined) this.DistFunc = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('InvFunc')[0];
      if (wPtr != undefined) this.InvFunc = wPtr.childNodes[0].nodeValue ;
      wPtr = wDistTag[ix].getElementsByTagName('MirrFunc')[0];
      if (wPtr != undefined) this.MirrFunc = wPtr.childNodes[0].nodeValue ;


     // default error condition for all distributions

      this.ErrorCond[0] = "wPct < 0 || wPct > 100";
      this.ErrorMsg[0] = "choose percentage between 0 and 100 ";

      var wErr = wDistTag[ix].getElementsByTagName('Error');
      if (wErr != undefined)
      {
         for (var wix = 0; wix < wErr.length; wix++)
         {
            var errIx = this.ErrorCond.length;
            this.ErrorCond[errIx] = wErr[wix].getElementsByTagName('Condition')[0].childNodes[0].nodeValue;
            this.ErrorMsg[errIx] = wErr[wix].getElementsByTagName('Message')[0].childNodes[0].nodeValue;
         }
      }

      var wParm = wDistTag[ix].getElementsByTagName('Parm');
      if (wParm != undefined)
      {
         for (var wix = 0; wix < wParm.length; wix++)
         {
            var parmIx = this.ParmLead.length;
            this.ParmLead[parmIx] = wParm[wix].getElementsByTagName('Lead')[0].childNodes[0].nodeValue;
            this.ParmDefault[parmIx] = wParm[wix].getElementsByTagName('Default')[0].childNodes[0].nodeValue;
         }
      }
      if ( this.Type != undefined)
         if ("DISCRETE".indexOf(this.Type.toUpperCase()) == 0)
            this.discrete = true;
      this.continuous = !this.discrete;
   }
}
// ------------------------------------------------------------------------
// Define error condition and resulting message
// ------------------------------------------------------------------------
function cDistribution_DefineError(iErrorCond,iErrorMsg)
{
   var errIx = this.ErrorCond.length;
   this.ErrorCond[errIx] = iErrorCond;
   this.ErrorMsg[errIx] = iErrorMsg;
}
// ------------------------------------------------------------------------
// Define error condition and resulting message
// ------------------------------------------------------------------------
function cDistribution_TestDisplay()
{
     document.write("<table>");
     document.write("<tr><td>DistId:</td><td>" + this.DistId + "</td></tr>");
     document.write("<tr><td>Type:</td><td>" + this.Type + "</td></tr>");
     document.write("<tr><td>discrete:</td><td>" + this.discrete + "</td></tr>");
     document.write("<tr><td>Name:</td><td>" + this.Name + "</td></tr>");
     document.write("<tr><td>Eqn:</td><td>" + this.Eqn + "</td></tr>");
     document.write("<tr><td>DensFunc:</td><td>" + this.DensFunc + "</td></tr>");
     document.write("<tr><td>Range:</td><td>" + this.Range + "</td></tr>");
     document.write("<tr><td>Start:</td><td>" + this.Start + "</td></tr>");
     document.write("<tr><td>Xmax:</td><td>" + this.Xmax + "</td></tr>");
     document.write("<tr><td>DistFunc:</td><td>" + this.DistFunc + "</td></tr>");
     document.write("<tr><td>InvFunc:</td><td>" + this.InvFunc + "</td></tr>");
     document.write("<tr><td>MirrFunc:</td><td>" + this.MirrFunc + "</td></tr>");
     document.write("<tr><td>Parms:</td><td>" + this.ParmLead.length + "</td></tr>");
     document.write("<tr><td>TwoTailed:</td><td>" + this.TwoTailed + "</td></tr>");
     document.write("<tr><td>Reference:</td><td>" + this.Reference + "</td></tr>");
     for (var wix=0; wix<this.ParmLead.length; wix++)
     {
        document.write("<tr><td>Lead["+ wix +"]:</td><td>" + this.ParmLead[wix] + "</td></tr>");
        document.write("<tr><td>Default["+ wix +"]:</td><td>" + this.ParmDefault[wix] + "</td></tr>");
     }
     for (var wix=0; wix<this.ErrorCond.length; wix++)
     {
        document.write("<tr><td>Condition["+ wix +"]:</td><td>" + this.ErrorCond[wix] + "</td></tr>");
        document.write("<tr><td>Message["+ wix +"]:</td><td>" + this.ErrorMsg[wix] + "</td></tr>");
     }
     document.write("</table>");
     document.write("<hr />");
}
// ------------------------------------------------------------------------
// Draw input form for parameters and test value or percentage point
// ------------------------------------------------------------------------
function cDistribution_DrawForm()
{
   var wFormId = this.Reference + "Fm";
//   alert("<form id='" + wFormId + "' name='" + wFormId + "'><table class='stats' border='0' >");
   document.write("<form id='" + wFormId + "' name='" + wFormId + "'><table class='stats' border='0' >");
/* */
   document.write("<tr><td colspan=2 class='title'>" + this.Name + " distribution</td></tr>");
   document.write("<tr><td colspan=2 class='title'>");
   document.write(this.Eqn);
   document.write("</td></tr>");
   document.write("<tr><td class='leader'>" + this.ParmLead[0] + ": </td> " +
      "<td><input type='text' id='wParm1' name='wParm1' value='" + this.ParmDefault[0] + "'/></td> </tr>");
   if( this.ParmLead.length > 1)
      document.write("<tr><td class='leader'>" + this.ParmLead[1] + ": </td> " +
         "<td><input type='text' id='wParm2' name='wParm2' value='" + this.ParmDefault[1] + "'/></td> </tr>");
   if( this.ParmLead.length > 2)
      document.write("<tr><td class='leader'>" + this.ParmLead[2] + ": </td> " +
         "<td><input type='text' id='wParm3' name='wParm3' value='" + this.ParmDefault[2] + "'/></td> </tr>");
   document.write("<tr><td colspan='2'><hr /></td></tr>");
   document.write("<tr><td class='leader'>Test value: </td>" +
      "<td><input type='text' id='wVal' name='wVal' value='0'/></td> </tr>");
   if ( this.MirrFunc != undefined )
//   if( this.TwoTailed)
   {
      document.write("<td colspan='2'><table align='center'>");
      document.write("<tr><td align='center'><input type='button' name='tail1' value='Distrib.'" +
         "onclick=\" " + this.Reference + ".Display(1)\" style='background:#787;color:#bfb;font-weight:bold'/></td>");
      document.write("<td align='center'><input type='button' name='tail2' value='2-tailed'" + 
         "onclick=\" " + this.Reference + ".Display(2)\" style='background:#787;color:#bfb;font-weight:bold'/></td>");
      document.write("</table></td>");
   }
   else
      document.write("<tr><td colspan=2 align='center'><input type='button' name='tail1' value='Distribution'" +
         "onclick=\"" + this.Reference + ".Display(1)\" style='background:#787;color:#bfb;font-weight:bold'/></td>");
   document.write("<tr><td class='leader'>Percentage: </td>" +
      "<td><input type='text' id='wPct' name='wPct' value='5'/></td> </tr>");
   document.write("<tr><td colspan='2' align='center'> <input type='button' name='pct' value='% point'" + 
      "onclick=\"" + this.Reference + ".Display(3)\" style='background:#787;color:#bfb;font-weight:bold'/></td> </tr>");
/* */
   document.write("</table></form>"); 
}
// ------------------------------------------------------------------------
// Display graph of density functions and various statistics on new page
// ------------------------------------------------------------------------
function cDistribution_Display(wCalcType)
{
   // --- constants
   var ONETAIL = 1; // calc distr, show 1-tail
   var TWOTAIL = 2; // calc distr, show 2-tail
   var PCTPOINT = 3; // calc %pt, show 1-tail

   var wDensFunc; // the density function for the distribution
   var wMaxX;

   // --- establish which form:
   var wForm;
   eval("wForm = " + this.Reference + "Fm");
//   alert(wForm);
   // --- read input parameters:
   var wPct = 1 * wForm.wPct.value;
   var wParm1 = 1 * wForm.wParm1.value;
   var wParm2;
   if (this.ParmLead.length > 1)
      wParm2 = 1 * wForm.wParm2.value;
   var wParm3;
   if (this.ParmLead.length > 2)
      wParm3 = 1 * wForm.wParm3.value;
   var wVal = 1 * wForm.wVal.value;

//   alert(wVal + "\n" + wParm1 + "\n" + wParm2);

   // --- validate input parameters
   for (var errIx=0; errIx < this.ErrorCond.length; errIx++)
   {
      if (eval(this.ErrorCond[errIx]))
      {
         alert (this.ErrorMsg[errIx]);
         return;
      }
   }

   // --------------------------------------------------------------
   // Calculate distributions, %points, probabilities
   // --------------------------------------------------------------

   // --- if calculating %point the test value is calculated
   //     and the distribution of test value + 1
   var wTestDistP; // the distribution of 1 + calculated value
   var xBelowZero = false;
   if (wCalcType == PCTPOINT)
   {
      wVal = this.CalcInvFunc(wPct/100,wParm1,wParm2,wParm3);
      if (this.discrete)
         if (wVal >= 0)
            wTestDistP = this.DistFunc(wVal+1,wParm1,wParm2,wParm3);
         else
         {
            xBelowZero = true;  // remember this
            wVal = 0;
         }
   }
   // --- now do the reverse, calculate the exact distribution (percantage) for the value.
   //     Note: for discrete distributions this may differ from % given
   var wTestDist ; // the distribution of calculated value
   wTestDist = this.CalcDistFunc(wVal, wParm1,wParm2,wParm3);

   // --- reset the calculated value on form
   if (wCalcType == PCTPOINT)
      wForm.wVal.value = Math.floor(wVal*100000+0.5)/100000 ;
   else
      wForm.wPct.value = Math.floor(wTestDist*100*1000+0.5)/1000 ;

   // --- build up density function (will also be used on graph, hence 'x')
   if (this.ParmLead.length == 1)
      wDensFunc = this.DensFunc + "(x," + wParm1 + ")";
   else if (this.ParmLead.length == 2)
      wDensFunc = this.DensFunc + "(x," + wParm1 + "," + wParm2 + ")";
   else if (this.ParmLead.length == 3)
      wDensFunc = this.DensFunc + "(x," + wParm1 + "," + wParm2 + "," + wParm3 + ")";

   // --- calculate the exact probability for value in discrete distribution
   var wProb; // the probability of the value (discrete only)
   if (this.discrete)
   {
      x = wVal;
      wProb = eval(wDensFunc);
   }

   // --- calculate 1- and 2- tailed sign.prob. ---
   eval("var wRange = " + this.Range);
   eval("var wStart = " + this.Start);

   var wMinVal = wStart;
   var wMaxVal = wStart+wRange;

   var wTailOne;
   var wTailTwo;
   var wValMirr;

   var wCutoffLow;
   var wCutoffHigh;
   var wOneTailSP;
   var wTwoTailSP;

   var discInc = 0;
   if (this.discrete)
      discInc = 1;

   if ( this.MirrFunc != undefined )
   {
      wValMirr = this.CalcMirrFunc(wVal, wParm1, wParm2, wParm3);
      if (wValMirr == wVal)
      {
         wCutoffHigh = wVal;
         wCutoffLow = wValMirr - discInc;
      }
      else if (wValMirr > wVal)
      {
         wCutoffHigh = wValMirr;
         wCutoffLow = wVal;
      }
      else
      {
         wCutoffHigh = wVal;
         wCutoffLow = wValMirr;
      }
      var SPLow
      if (wCutoffLow < wMinVal)
         SPLow = 0;
      else
         SPLow = this.CalcDistFunc(wCutoffLow,wParm1,wParm2,wParm3);
      var SPHigh
      if (wCutoffHigh > wMaxVal)
         SPHigh = 0;
      else
         SPHigh = 1 - this.CalcDistFunc(wCutoffHigh-discInc,wParm1,wParm2,wParm3);
      if (wCutoffLow == wVal)
         wOneTailSP = SPLow;
      else
         wOneTailSP = SPHigh;
      wTwoTailSP = SPLow + SPHigh;
   }

   // --------------------------------------------------------------
   // Calculate graph
   // --------------------------------------------------------------

   eval("wMaxX = " + this.Xmax) ;
   var wLow;
   var wHigh;
   if (wCalcType == TWOTAIL)
   {
      wLow = wCutoffLow;
      wHigh = wCutoffHigh;
      if (this.discrete)
         wHigh -= 0.5;
   }
   else
      wLow = wVal;
   if (this.discrete)
      wLow += 0.5;
   if (wLow > wRange + wStart)
      wLow = wRange + wStart;
   x = wMaxX;
//   alert("x: " + x +"\n"+wDensFunc);
   var wMaxY = eval(wDensFunc);
//   alert("max " + wMaxY);
   var wXint = wRange < 1 ? 0.1 :wRange < 2 ? 0.5 :wRange < 10 ? 1 : wRange < 25 ? 5 : wRange < 60 ? 10 : wRange < 100 ? 25 : wRange < 200 ? 50 : 100;
   var wGraph = new cGraph(300,300);
   wYstretch = 2*wRange/(3*wMaxY);
   var wYpow = Math.floor(Math.log(wYstretch)/Math.log(10));
   var wYcom = Math.floor(wYstretch/Math.pow(10,wYpow)+0.5);
   wYcom = wYcom < 2 ? 1 : wYcom < 5 ? 2.5 : 5;
   wYstretch = wYcom * Math.pow(10,wYpow);
   wGraph.setYstretch(wYstretch);
   wGraph.setXgrid(wXint);
   if (this.discrete)
      wGraph.drawStep(wDensFunc,1,"on",wStart,wStart+wRange);
   else
      wGraph.drawFunction(wDensFunc,wStart,wStart+wRange);
   if (wLow != undefined && wLow > wStart)
   {
//      alert(wStart + ", " + wLow );
      wGraph.addShade(wStart, wLow);
   }
   if (wHigh != undefined)
   {
//      alert(wHigh + ", " + (wStart +  wRange));
      wGraph.addShade(wHigh,wStart+wRange);
   }

   // --------------------------------------------------------------
   // Draw window
   // --------------------------------------------------------------

   var myWin=window.open('','',
      "toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes",false);
   myWin.document.open("text/html","replace");

   myWin.document.write("<html><head><title>" + this.Name + " Distribution</title>" +
      "</head><body style=\";background-color:#cec\">");
   myWin.document.write("<div style=\"text-align:center\">");
   myWin.document.write("Graph of <b>" + this.Name + "</b> density function:<br />");
   wGraph.print(myWin);

   var wTitle = this.Name + " distribution with " + this.ParmLead[0] + ": " + wParm1
   if (this.ParmLead.length > 1)
      wTitle += ", " + this.ParmLead[1] + ": " + wParm2;
   if (this.ParmLead.length > 2)
      wTitle += ", " + this.ParmLead[2] + ": " + wParm3;

   myWin.document.write("<p>" + wTitle + "</p>");
   myWin.document.write ("<table border='0'>");

   var wDp = this.discrete ? 0 : 4; // number of decimal places to show on values

   if (this.discrete)
   {
      myWin.document.write ("<tr><td></td><td>P ( <i>x</i> = " +
         formatDec(wVal,wDp) + " ) :</td>");
      myWin.document.write ("<td><b>" + formatDec(wProb,4) + "</b> (<b>" +
         formatDec(100*wProb,2) + "%</b>)</td></tr>") ;
      if (wCalcType == PCTPOINT)
      {
         if (xBelowZero)
            myWin.document.write ("<tr><td colspan='3'>The " + formatDec(wPct,2) + "% point lies below 0 :</td>");
         else
            myWin.document.write ("<tr><td colspan='3'>The " + formatDec(wPct,2) + "% point lies between " +
               formatDec(wVal,wDp) + "  and " + formatDec(wVal+1,wDp) + " :</td>");
      }
   }
   myWin.document.write ("<tr><td width='10'></td><td>P ( <i>x</i> &le; " +
      formatDec(wVal,wDp) + " ) :</td>");
   myWin.document.write ("<td><b>" + formatDec(wTestDist,4) + "</b> (<b>" +
      formatDec(100*wTestDist,2) + "%</b>)</td></tr>") ;
   if (this.discrete && wCalcType == PCTPOINT && !xBelowZero)
   {
      myWin.document.write ("<tr><td></td><td>P ( <i>x</i> &le; " +
         formatDec(wVal+1,wDp) + " ) :</td>");
      myWin.document.write ("<td><b>" + formatDec(wTestDistP,4) + "</b> (<b>" +
         formatDec(100*wTestDistP,2) + "%</b>)</td></tr>") ;
   }
   myWin.document.write ("<tr><td></td><td>P ( <i>x</i> &gt; " +
      formatDec(wVal,wDp) + " ) :</td>");
   myWin.document.write ("<td><b>" + formatDec(1-wTestDist,4) + "</b> (<b>" +
      formatDec(100*(1-wTestDist),2) + "%</b>)</td></tr>") ;


   if ( this.MirrFunc != undefined )
   {
      myWin.document.write ("<tr><td class='title' colspan='3'>Significance Probability: </td></tr>");

      myWin.document.write ("<tr><td></td><td class='title'>One-tailed: </td>");
      myWin.document.write ("<td><b>" + formatDec(wOneTailSP,4) + "</b> (<b>" + formatDec(100*wOneTailSP,2) + "%</b>)</td>") ;
      if (wTestDist < 0.5)
         myWin.document.write ("<td colspan='2'> [ = P ( <i>x</i> &le; " +  formatDec(wCutoffLow,wDp) +  " ) ]</td>");
      else if ( this.discrete &&  this.CalcDistFunc(wVal - 1 , wParm1,wParm2,wParm3) < 0.5 )
         myWin.document.write ("<td colspan='2'> [ = P ( <i>x</i> &le; " +  formatDec(wCutoffLow,wDp) +  " ) ]</td>");
      else
         myWin.document.write ("<td colspan='2'> [ = P ( <i>x</i> &ge; " +  formatDec(wCutoffHigh,wDp) +  " ) ]</td>");
      myWin.document.write ("</tr>");

      myWin.document.write ("<tr><td></td><td class='title'>Two-tailed: </td>");
      myWin.document.write ("<td><b>" + formatDec(wTwoTailSP,4) + "</b> (<b>" +
         formatDec(100*wTwoTailSP,2) + "%</b>)</td>") ;
      myWin.document.write ("<td colspan='2'>[ = ");
      if (wCutoffLow >=  wMinVal)
         myWin.document.write ("P ( <i>x</i> &le; " +  formatDec(wCutoffLow,wDp) + " )");
      if (wCutoffHigh <=  wMaxVal)
      {
         if (wCutoffLow >=  wMinVal)
            myWin.document.write (" + ");
         myWin.document.write ("P ( <i>x</i> &ge; " +  formatDec(wCutoffHigh,wDp) + " )");
      }
      myWin.document.write ("]</td>");
      myWin.document.write ("</tr>");
   }
   myWin.document.write ("</table>");

   myWin.document.write("<br /><form><input type='button' value='Close Window' " +
      "onClick=\"window.close()\"></form>");
   myWin.document.write("</div></body></html>");
}
// ------------------------------------------------------------------------
// call the inverse distribution function with the correct number of parms
// ------------------------------------------------------------------------
function cDistribution_CalcInvFunc(wProb,wParm1,wParm2,wParm3)
{
   return eval(this.BuildFunc(this.InvFunc,wProb,wParm1,wParm2,wParm3));
}
// ------------------------------------------------------------------------
// call the distribution function with the correct number of parms
// ------------------------------------------------------------------------
function cDistribution_CalcDistFunc(wVal,wParm1,wParm2,wParm3)
{
   return eval(this.BuildFunc(this.DistFunc,wVal,wParm1,wParm2,wParm3));
}
// ------------------------------------------------------------------------
// call the mirror function with the correct number of parms
// ------------------------------------------------------------------------
function cDistribution_CalcMirrFunc(wVal,wParm1,wParm2,wParm3)
{
   return eval(this.BuildFunc(this.MirrFunc,wVal,wParm1,wParm2,wParm3));
}
// ------------------------------------------------------------------------
// builds an executable string of function with the correct number of parms
// ------------------------------------------------------------------------
function cDistribution_BuildFunc(wFunc,wVal,wParm1,wParm2,wParm3)
{
   var wFuncExpr;
   if (this.ParmLead.length == 1)
      wFuncExpr = wFunc + "(" + wVal + "," + wParm1 + ")";
   else if (this.ParmLead.length == 2)
      wFuncExpr = wFunc + "(" + wVal + "," + wParm1 + "," + wParm2 + ")";
   else if (this.ParmLead.length == 3)
      wFuncExpr = wFunc + "(" + wVal + "," + wParm1 + "," + wParm2 + "," + wParm3 + ")";
   return wFuncExpr;
}
// ------------------------------------------------------------------------
// functions to ease defining conditions
// ------------------------------------------------------------------------
function PosInt(wX) { if (Math.floor(wX) == wX && wX > 0) return true; else return false; }
function ProbVal(wX) { if (wX > 1 || wX < 0) return false; else return true; }
