// * modified March 2008 to accomodate Mathyma v3

 var cMatrix_Precision = 2;
 var bShowWorking = false;
 var WMATPAD = " ";
// =========================================================================
// Class: cMatrix
// =========================================================================
function cMatrix(iTxt)
{
   this.XElt = new Array();
   this.RowCount;
   this.ColCount;
   this.XRank;
   this.XPreMultip;
   this.XPostMultip;
   this.XDeterminant;

   if (iTxt != undefined)
   {
      if (iTxt instanceof Array)
      {
         this.RowCount = iTxt.length;
         this.ColCount = 0;
         for (var rIx = 0; rIx < iTxt.length; rIx++)
         {
            this.XElt[rIx] = new Array();
            for (var cIx = 0; cIx < iTxt[rIx].length; cIx++)
               this.XElt[rIx].push(iTxt[rIx][cIx]);
            if (this.ColCount < this.XElt[rIx].length)
               this.ColCount = this.XElt[rIx].length;
         }
      }
      else if (iTxt.charAt(0).toUpperCase() == "I")
      {
         var wIdim = iTxt.substr(1);
         if (isNaN(wIdim))
            alert ("Incorrect parameters for Matrix creation:\nnew cMatrix (\"" + iTxt + "\")" );
         else
         {
         this.ColCount = this.RowCount = wIdim;
         // build array of row arrays
            for (var ix = 0; ix < this.RowCount; ix++)
            {
               this.XElt[ix] = new Array();
               for (var jx = 0; jx < this.ColCount; jx++)
               {
                  if (ix == jx)
                     this.XElt[ix][jx] = 1;
                  else
                     this.XElt[ix][jx] = 0;
               }
            }
         }
      }
      else if (iTxt.charAt(0).toUpperCase() == "Z")
      {
         var wParms = iTxt.split(",");
         if (wParms.length < 2 )
            alert ("Incorrect parameters for Matrix creation:\nnew cMatrix (\"" + iTxt + "\")" );
         else
         {
            this.RowCount = wParms[1];
            if (wParms.length < 3 )
               this.ColCount = wParms[1];
            else
               this.ColCount = wParms[2];
            // build array of row arrays
            for (var ix = 0; ix < this.RowCount; ix++)
            {
               this.XElt[ix] = new Array();
               for (var jx = 0; jx < this.ColCount; jx++)
                  this.XElt[ix][jx] = 0;
            }
         }
      }
      else if (iTxt.charAt(0).toUpperCase() == "D")
      {
         var wParms = iTxt.split(",");
         this.ColCount = this.RowCount = wParms.length - 1;
         // build array of row arrays
         for (var ix = 0; ix < this.RowCount; ix++)
         {
            this.XElt[ix] = new Array();
            for (var jx = 0; jx < this.ColCount; jx++)
            {
               if (ix == jx)
                  this.XElt[ix][jx] = wParms[ix+1];
               else
                  this.XElt[ix][jx] = 0;
            }
         }
      }
      else
      {
         wRows = iTxt.split("/");
         this.RowCount = wRows.length;
         this.ColCount = 0;
         // build array of row arrays
         for (var ix = 0; ix < wRows.length; ix++)
         {
            this.XElt[ix] = wRows[ix].split(",");
            if (this.ColCount < this.XElt[ix].length)
               this.ColCount = this.XElt[ix].length;
         }
      }
      // pad out short rows with zeros
      for (var ix = 0; ix < this.XElt.length; ix++)
         for (var jx = this.XElt[ix].length; jx < this.ColCount; jx ++)
            this.XElt[ix][jx] = 0;
   }

//** Methods
   this.Dump          = cMatrix_Dump;
   this.Print         = cMatrix_Print;
   this.McPrint       = cMatrix_McPrint;
   this.VConcat       = cMatrix_VConcat;
   this.HConcat       = cMatrix_HConcat;
   this.Transpose     = cMatrix_Transpose;
   this.Trans         = cMatrix_Transpose;
   this.Times         = cMatrix_Mult;
   this.Mult          = cMatrix_Mult;
   this.Multiply      = cMatrix_Mult;
   this.Prod          = cMatrix_Mult;
   this.Product       = cMatrix_Mult;
   this.Plus          = cMatrix_Plus;
   this.Add           = cMatrix_Plus;
   this.Sum           = cMatrix_Plus;
   this.Minus         = cMatrix_Minus;
   this.Subtract      = cMatrix_Minus;
   this.Difference    = cMatrix_Minus;
   this.ElementMult   = cMatrix_ElementMult;
   this.ElementDiv    = cMatrix_ElementDiv;
   this.ElementOper   = cMatrix_ElementOper;
   this.Element       = cMatrix_Element;
   this.Elt           = cMatrix_Element;
   this.Row           = cMatrix_Row;
   this.Col           = cMatrix_Col;
   this.Determinant   = cMatrix_Determinant;
   this.Det           = cMatrix_Determinant;
   this.GenInverse    = cMatrix_GInv;
   this.GenInv        = cMatrix_GInv;
   this.GInv          = cMatrix_GInv;
   this.Inverse       = cMatrix_Inverse;
   this.Inv           = cMatrix_Inverse;
   this.Rank          = cMatrix_Rank;
   this.PreMultip     = cMatrix_PreMultip;
   this.PostMultip    = cMatrix_PostMultip;
   this.CalcPreInv    = cMatrix_CalcPreInv;
   this.CalcRank      = cMatrix_CalcRank;
   this.Adjugate      = cMatrix_Adjoint;
   this.Adjoint       = cMatrix_Adjoint;
   this.Copy          = cMatrix_Copy;
   this.ElmRowSub     = cMatrix_ElmRowSub;
   this.ElmColSub     = cMatrix_ElmColSub;
   this.ElmSwap       = cMatrix_ElmSwap;
   this.ElmMult       = cMatrix_ElmMult;
   this.ScalarMult    = cMatrix_ScalarMult;
}
// -------------------------------------------------------------------------
// prints the matrix on the page (for debugging)
// -------------------------------------------------------------------------
function cMatrix_Dump()
{
   document.write("<table>");
   for (rowIx = 0; rowIx < this.XElt.length; rowIx++)
   {
      document.write("<tr>");
      for (colIx = 0; colIx < this.XElt[rowIx].length; colIx++)
         document.write("<td>" + this.XElt[rowIx][colIx] + "</td>");
      document.write("</tr>");
   }
   document.write("</table>");
}
// -------------------------------------------------------------------------
// writes matrix in mathyma (v3) format to page
// -------------------------------------------------------------------------
function cMatrix_Print()
{
   document.write(this.McPrint());
}
// -------------------------------------------------------------------------
// writes matrix string in mathyma (v3) format
// -------------------------------------------------------------------------
function cMatrix_McPrint()
{
   wTxt = "matrix{";
   for (rowIx = 0; rowIx < this.XElt.length; rowIx++)
   {
      if (rowIx > 0) wTxt += "/";
      for (colIx = 0; colIx < this.XElt[rowIx].length; colIx++)
      {
         if (colIx > 0) wTxt += ",";
         wTxt += WMATPAD + formatDec(this.XElt[rowIx][colIx],cMatrix_Precision) + WMATPAD;
      }
   }
   wTxt += "}";
   return wTxt;
}
// -------------------------------------------------------------------------
// Vertical Concatenation of the matrix with another matrix
// -------------------------------------------------------------------------
function cMatrix_VConcat(MatB)
{
   if (this.ColCount != MatB.ColCount)
      alert ("Incompatible dimensions for vertical concatenation\n" +
       this.RowCount + "x" + this.ColCount + " // " + MatB.RowCount + "x" + MatB.ColCount );
   else
   {
      var wConcat = this.Copy();
      for (var rowIx = 0; rowIx < MatB.XElt.length; rowIx++)
      {
         wConcat.XElt[wConcat.RowCount] = new Array();
         for (var colIx = 0; colIx < MatB.XElt[rowIx].length; colIx++)
            wConcat.XElt[wConcat.RowCount][colIx]= MatB.XElt[rowIx][colIx];
         wConcat.RowCount++;
      }
      return wConcat
   }
}
// -------------------------------------------------------------------------
// Horizontal Concatenation of the matrix with another matrix
// -------------------------------------------------------------------------
function cMatrix_HConcat(MatB)
{
   return this.Trans().VConcat(MatB.Trans()).Trans()
}
// -------------------------------------------------------------------------
// Transpose of a matrix
// -------------------------------------------------------------------------
function cMatrix_Transpose()
{
   var wTrans = new cMatrix();
   for (rowIx = 0; rowIx < this.XElt.length; rowIx++)
      for (colIx = 0; colIx < this.XElt[rowIx].length; colIx++)
      {
         if (wTrans.XElt[colIx] == undefined)
            wTrans.XElt[colIx] = new Array();
         wTrans.XElt[colIx][rowIx]= this.XElt[rowIx][colIx];
      }
   wTrans.RowCount = this.ColCount;
   wTrans.ColCount = this.RowCount;
   return wTrans;
}
// -------------------------------------------------------------------------
// Product of the matrix with another matrix
// -------------------------------------------------------------------------
function cMatrix_Mult(MatB)
{
   if (this.ColCount != MatB.RowCount)
      alert ("Incompatible dimensions for matrix multiplication\n" +
       this.RowCount + "x" + this.ColCount + " times " + MatB.RowCount + "x" + MatB.ColCount );
   else
   {
      var wProd = new cMatrix();
      var MatC = MatB.Transpose();
      for (var aIx = 0; aIx < this.XElt.length; aIx++)
         for (var cIx = 0; cIx < MatC.XElt.length; cIx++)
         {
            if (wProd.XElt[aIx] == undefined)
               wProd.XElt[aIx] = new Array();
            wProd.XElt[aIx][cIx] = (this.Row(aIx+1)).Dot(MatC.Row(cIx+1));
         }
      wProd.RowCount = this.RowCount;
      wProd.ColCount = MatB.ColCount;
      return wProd;
   }
}
// -------------------------------------------------------------------------
// Sum of the matrix with another matrix (element by element addition)
// -------------------------------------------------------------------------
function cMatrix_Plus(MatB)
{
      return this.ElementOper(MatB,"+");
}
// -------------------------------------------------------------------------
// Difference of the matrix and another (element by element subtraction)
// -------------------------------------------------------------------------
function cMatrix_Minus(MatB)
{
      return this.ElementOper(MatB,"-");
}
// -------------------------------------------------------------------------
// Element by element multiplication
// -------------------------------------------------------------------------
function cMatrix_ElementMult(MatB)
{
      return this.ElementOper(MatB,"*");
}
// -------------------------------------------------------------------------
// Element by element division
// -------------------------------------------------------------------------
function cMatrix_ElementDiv(MatB)
{
      return this.ElementOper(MatB,"/");
}
// -------------------------------------------------------------------------
// Perform element by element operation for the above four methods
// -------------------------------------------------------------------------
function cMatrix_ElementOper(MatB,wOper)
{
   var wOperName;
   var wResult;
   if (wOper == "+") wOperName = "Addition";
   if (wOper == "-") wOperName = "Subtraction";
   if (wOper == "*") wOperName = "Multiplication";
   if (wOper == "/") wOperName = "Division";
   if ((this.ColCount != MatB.ColCount) || (this.RowCount != MatB.RowCount))
      alert ("Incompatible dimensions for matrix " + OperName + "\n" +
       this.RowCount + "x" + this.ColCount + " + " + MatB.RowCount + "x" + MatB.ColCount );
   else
   {
      wResult = new cMatrix();
      for (var rIx = 0; rIx < this.RowCount; rIx++)
      {
         wResult.XElt[rIx] = new Array();
         for (var cIx = 0; cIx < this.ColCount; cIx++)
         {
            if (wOper == "+")
               wResult.XElt[rIx][cIx] = (1 * this.XElt[rIx][cIx]) + (1 * MatB.XElt[rIx][cIx]);
            if (wOper == "-")
               wResult.XElt[rIx][cIx] = (1 * this.XElt[rIx][cIx]) - (1 * MatB.XElt[rIx][cIx]);
            if (wOper == "*")
               wResult.XElt[rIx][cIx] = this.XElt[rIx][cIx] * MatB.XElt[rIx][cIx];
            if (wOper == "/")
               wResult.XElt[rIx][cIx] = this.XElt[rIx][cIx] / MatB.XElt[rIx][cIx];
         }
      }
      wResult.RowCount = this.RowCount;
      wResult.ColCount = this.ColCount;
   }
   return wResult;
}
// -------------------------------------------------------------------------
// Returns given element of the matrix
// (mathematical row and column numbering)
// -------------------------------------------------------------------------
function cMatrix_Element(iRowIx,iColIx)
{
   var rowIx = iRowIx - 1;
   var colIx = iColIx - 1;
   if ((0 > rowIx) || (rowIx > this.RowCount - 1) ||
      (0 > colIx) || (colIx > this.ColCount - 1))
      alert ("Element (" + iRowIx + "," + iColIx + ") is out of [ " +
         this.RowCount + "x" + this.ColCount + " ] matrix bounds");
   else
      return this.XElt[rowIx][colIx];
}
// -------------------------------------------------------------------------
// Returns given row of the matrix as a vector (mathematical row numbering)
// -------------------------------------------------------------------------
function cMatrix_Row(iRowIx)
{
   var rowIx = iRowIx - 1;
   if (rowIx < this.XElt.length)
   {
      rowVec =  new cVector(this.XElt[rowIx]);
      return rowVec;
   }
   else
      alert ("Row " + iRowIx + " is out of [ " +
         this.RowCount + "x" + this.ColCount + " ] matrix bounds");
}
// -------------------------------------------------------------------------
// Returns given column of the matrix as a vector
// (mathematical column numbering)
// -------------------------------------------------------------------------
function cMatrix_Col(iColIx)
{
   var colIx = iColIx - 1;
   if (colIx < this.XElt[0].length)
   {
      var colArray = new Array();
      for (var rowIx = 0; rowIx < this.XElt.length; rowIx++)
         colArray[rowIx] = this.XElt[rowIx][colIx];
      colVec =  new cVector(colArray);
      return colVec;
   }
   else
      alert ("Col " + iColIx + " is out of [ " +
         this.RowCount + "x" + this.ColCount + " ] matrix bounds");
}
// -------------------------------------------------------------------------
// Rank of matrix
// -------------------------------------------------------------------------
function cMatrix_Rank()
{
   if (this.XRank == undefined)
      this.CalcRank(false);
   return this.XRank;
}
// -------------------------------------------------------------------------
// Pre Multiplier of matrix [ = M where MAN = C = I 0    ]
//                                                0 0
// -------------------------------------------------------------------------
function cMatrix_PreMultip()
{
   if (this.XRank == undefined)
      this.CalcRank(false);
   return this.XPreMultip;
}
// -------------------------------------------------------------------------
// Post Multiplier of matrix [ = N where MAN = C = I 0    ]
//                                                 0 0
// -------------------------------------------------------------------------
function cMatrix_PostMultip()
{
   if (this.XRank == undefined)
      this.CalcRank(false);
   return this.XPostMultip;
}
// -------------------------------------------------------------------------
// Determinant of matrix
// -------------------------------------------------------------------------
function cMatrix_Determinant()
{
   if (this.ColCount != this.RowCount)
   {
      alert ("Matrix is " + this.RowCount + " x " + this.ColCount +
        "\nOnly square matrices can have a determinant");
      return;
   }
   if (this.XRank == undefined)
      this.CalcRank(false);
   return this.XDeterminant;
}
// -------------------------------------------------------------------------
// Inverse of matrix
// -------------------------------------------------------------------------
function cMatrix_Inverse()
{
   if (this.ColCount != this.RowCount)
   {
      alert ("Matrix is " + this.RowCount + " x " + this.ColCount +
        "\nOnly square matrices can have an inverse");
      return;
   }
   if (this.XRank == undefined)
      this.CalcRank(false);
   if (this.XRank != this.RowCount)
   {
      alert (this.RowCount + " x " + this.ColCount + " matrix, rank = " + this.XRank +
        "\nNot full rank - inverse does not exist." );
      return;
   }
   return this.XPreMultip;
}
// -------------------------------------------------------------------------
// Moore-Penrose General Inverse of matrix
// -------------------------------------------------------------------------
function cMatrix_GInv()
{
   if (this.XRank == undefined)
      this.CalcRank(false);
   var MatM = this.XPreMultip;
   var MatN = this.XPostMultip;
   var wRank = this.XRank;
   var wIdent = new cMatrix("I" + wRank);

   var wZeroMat = new cMatrix("Z," + (this.RowCount-wRank) + "," + wRank);
   var MatB = MatM.Inv().Mult(wIdent.VConcat(wZeroMat));

   var wZeroMat = new cMatrix("Z," + wRank + "," + (this.ColCount-wRank));
   var MatC = wIdent.HConcat(wZeroMat).Mult(MatN.Inv());

   var CtCCtm1 = MatC.Trans().Mult(( MatC.Mult(MatC.Trans()) ).Inv());
   var BtBm1Bt = ((MatB.Trans().Mult(MatB)).Inv()).Mult(MatB.Trans());

   var GInvMatA = CtCCtm1.Mult(BtBm1Bt);
   return GInvMatA;
}
// -------------------------------------------------------------------------
// Adjoint of matrix
// -------------------------------------------------------------------------
function cMatrix_Adjoint()
{
   if (this.ColCount != this.RowCount)
   {
      alert ("Matrix is " + this.RowCount + " x " + this.ColCount +
        "\nOnly square matrices can have an adjoint");
      return;
   }
   if (this.XRank == undefined)
      this.CalcRank(false);
   if (this.XRank != this.RowCount)
   {
      alert (this.RowCount + " x " + this.ColCount + " matrix, rank = " + this.XRank +
        "\nNot full rank - adjoint does not exist." );
      return;
   }
   return this.XPreMultip.ScalarMult(this.XDeterminant);
}
// -------------------------------------------------------------------------
// Calculate the Rank together with determinant and the pre- and post-
// multipliers of the matrix.
// The pre- and post- multipliers of the m*n matrix A ( of rank r ) are
// the m*m regular matrix M and the regular n*n matrix N such that
// MAN = C, where C is the r*r identity matrix embeded in an m*n matrix
// of zeros. (r = rank A) [THIS IS NOT STANDARD NOTATION]
// -------------------------------------------------------------------------
function cMatrix_CalcRank()
{
//   this.XDeterminant = 1;
   if (bShowWorking) document.write("<p><b>Calculating pre-multiplier</b></p>");
   this.XPreMultip = this.CalcPreInv();
   if (bShowWorking) document.write("<p><b>Calculating post-multiplier</b></p>");
   this.XPostMultip = this.XPreMultip.Mult(this.Copy()).Trans().CalcPreInv().Trans();
   var wRed = this.XPreMultip.Mult(this.Copy()).Mult(this.XPostMultip);
   if (bShowWorking)
      zEqn("reduced matrix :space{20}" + wRed.McPrint());
   this.XRank = 0;
   for (var colIx = 0; colIx < Math.min(wRed.ColCount,wRed.RowCount); colIx++)
      this.XRank += wRed.XElt[colIx][colIx];
   if (this.XRank != this.RowCount || this.XRank != this.ColCount)
      this.XDeterminant = 0;
   if (bShowWorking)
      document.write("rank = " + this.XRank + "<hr/>");
}
// -------------------------------------------------------------------------
// Calculates the Pre-Inverse (or Pre-multiplier) by Gauss reduction method
// -------------------------------------------------------------------------
function cMatrix_CalcPreInv()
{

   var wOrig = this.Copy();
   var wInvs = new cMatrix("I" + wOrig.RowCount);
   var colIx;
   var rowIx;
   this.XDeterminant = 1;
   if (bShowWorking)
   {
      document.write("<hr/>Initial matrices:");
      zEqn(wOrig.McPrint() + "space{20}" + wInvs.McPrint());
   }
   // for each column perform elementary row operations in order to
   // reduce the matrix to an upper triangular form with unit diagonal
   for (colIx = 0; colIx < wOrig.ColCount; colIx++)
   {
      // find the first non zero element (FNZE) below the diagonal in the column
      for (rowIx = colIx; rowIx < wOrig.RowCount && wOrig.XElt[rowIx][colIx] == 0; rowIx++);
      // if a non-zero element is found then perfom row operations
      if (rowIx != wOrig.RowCount)
      {
         // if FNZE is not diagonal element, swap rows
         if (rowIx != colIx)
         {
            if (bShowWorking)
               document.write("<p>swap row " + (rowIx+1) + " and row " + (colIx+1) + " </p>");
            wOrig = wOrig.ElmSwap(rowIx, colIx);
            wInvs = wInvs.ElmSwap(rowIx, colIx);
            this.XDeterminant *= -1;
            if (bShowWorking)
               zEqn(wOrig.McPrint() + "space{20}" + wInvs.McPrint() +
                  "space{20} det = " + formatDec(this.XDeterminant,4) );
         }
         // if diagonal element not 1, then multiply whole row
         if (wOrig.XElt[colIx][colIx] != 1)
         {
            var wScalar = 1/wOrig.XElt[colIx][colIx];
            if (bShowWorking)
               document.write("<p>multiply row " + (colIx+1) + " by  " + formatDec(wScalar,4) + " </p>");
            wOrig = wOrig.ElmMult(colIx, wScalar);
            wInvs = wInvs.ElmMult(colIx, wScalar);
            this.XDeterminant /= wScalar;
            if (bShowWorking)
               zEqn(wOrig.McPrint() + "space{20}" + wInvs.McPrint() +
                  "space{20} det = " + formatDec(this.XDeterminant,4) );
         }
         // subtract multiples of resulting row from lower rows to reduce rest of column to zeros
         for (rowIx = colIx + 1; rowIx < wOrig.RowCount; rowIx++)
         {
            if (wOrig.XElt[rowIx][colIx] != 0)
            {
               var wScalar = wOrig.XElt[rowIx][colIx];
               if (wScalar > 0.0000001 || wScalar < -0.0000001 )
               {
                  if (bShowWorking)
                     document.write("<p>subtract " + formatDec(wScalar,4) +
                        " times row " + (colIx+1) + " from row  " + (rowIx+1) + " </p>");
                  wOrig = wOrig.ElmRowSub(colIx, rowIx, wScalar);
                  wInvs = wInvs.ElmRowSub(colIx, rowIx, wScalar);
                  if (bShowWorking)
                     zEqn(wOrig.McPrint() + "space{20}" + wInvs.McPrint() +
                        "space{20} det = " + formatDec(this.XDeterminant,4) );
               }
            }
         }
      }
   }
   if (bShowWorking)
      document.write("<p><b>Now in echelon form</b></p>");

   //*** should now have diagonal of 1's and 0's
   // now reduce the elements above the diagonal to zero
   for (rowIx = 0; rowIx < wOrig.RowCount - 1 ; rowIx++)
      for (colIx = rowIx + 1; colIx < Math.min(wOrig.ColCount, wOrig.RowCount) ; colIx++)
         if (wOrig.XElt[rowIx][colIx] != 0)
         {
            wScalar = wOrig.XElt[rowIx][colIx];
            if (wScalar > 0.0000001 || wScalar < -0.0000001 )
            {
               if (bShowWorking)
                  document.write("<p>subtract " + formatDec(wScalar,4) +
                     " times row " + (colIx+1) + " from row  " + (rowIx+1) + " </p>");
               wOrig = wOrig.ElmRowSub(colIx, rowIx, wScalar);
               wInvs = wInvs.ElmRowSub(colIx, rowIx, wScalar);
               if (bShowWorking)
                  zEqn(wOrig.McPrint() + "space{20}" + wInvs.McPrint() +
                     "space{20} det = " + formatDec(this.XDeterminant,4) );
            }
         }

   if (bShowWorking) document.write("<hr/>");
   return wInvs;
}
// -------------------------------------------------------------------------
// Elementary row operation: multiply whole row by scalar
// -------------------------------------------------------------------------
function cMatrix_ElmMult(iRow, iScalar)
{
   var rMat = this.Copy();
   for (var colIx = 0; colIx < rMat.ColCount; colIx++)
   {
      rMat.XElt[iRow][colIx] *= iScalar;
   }
   return rMat;
}
// -------------------------------------------------------------------------
// Elementary row operation: swap two rows
// -------------------------------------------------------------------------
function cMatrix_ElmSwap(iRow1, iRow2)
{
   var rMat = this.Copy();
   var tempRow = new Array();
   tempRow = rMat.XElt[iRow1];
   rMat.XElt[iRow1] = rMat.XElt[iRow2];
   rMat.XElt[iRow2] = tempRow;
   return rMat;
}
// -------------------------------------------------------------------------
// Elementary row operation: subtract a multiple of one row from another
// -------------------------------------------------------------------------
function cMatrix_ElmRowSub(iRow1, iRow2, iMult)
{
   var rMat = this.Copy();
   for (var cIx = 0; cIx < rMat.ColCount; cIx++)
      rMat.XElt[iRow2][cIx] -= (iMult * rMat.XElt[iRow1][cIx]);
   return rMat;
}
// -------------------------------------------------------------------------
// Elementary column operation: subtract a multiple of one col from another
// -------------------------------------------------------------------------
function cMatrix_ElmColSub(iCol1, iCol2, iMult)
{
   var rMat = this.Copy();
   for (var rIx = 0; rIx < rMat.RowCount; rIx++)
      rMat.XElt[rIx][iCol2] -= (iMult * rMat.XElt[rIx][iCol1]);
   return rMat;
}
// -------------------------------------------------------------------------
// Create a new matrix as a copy of this one
// -------------------------------------------------------------------------
function cMatrix_Copy()
{
   var CopyMat = new cMatrix();
   for (var rowIx = 0; rowIx < this.RowCount; rowIx++)
   {
      CopyMat.XElt[rowIx] = new Array();
      for (var colIx = 0; colIx < this.ColCount; colIx++)
         CopyMat.XElt[rowIx][colIx] = this.XElt[rowIx][colIx];
   }
   CopyMat.RowCount = this.RowCount;
   CopyMat.ColCount = this.ColCount;
   return CopyMat;
}
// -------------------------------------------------------------------------
// Scalar multiplication of a matrix
// -------------------------------------------------------------------------
function cMatrix_ScalarMult(iScalar)
{
   var wMatrix = new cMatrix();
   for (rowIx = 0; rowIx < this.RowCount; rowIx++)
   {
      wMatrix.XElt[rowIx] = new Array();
      for (colIx = 0; colIx < this.ColCount ; colIx++)
         wMatrix.XElt[rowIx][colIx] = this.XElt[rowIx][colIx] * iScalar;
   }
   wMatrix.RowCount = this.RowCount;
   wMatrix.ColCount = this.ColCount;
   return wMatrix;
}
// =========================================================================
// Class: cVector
// =========================================================================
function cVector(iParm)
{
   this.XElt = new Array();

   if (iParm instanceof Array)
   {
      for (ix = 0; ix < iParm.length; ix++)
        this.XElt[ix] = iParm[ix];
   }
   else
   {
      this.XElt = iParm.split(",");
   }

//** Methods
   this.Dot         = cVector_Dot;
   this.Cross       = cVector_Cross;
   this.Angle       = cVector_Angle;
   this.Norm        = cVector_Norm;
   this.McPrint     = cVector_McPrint;
   this.ScalarMult  = cVector_ScalarMult;
   this.Plus        = cVector_Plus;
   this.Add         = cVector_Plus;
   this.Sum         = cVector_Plus;
   this.Minus       = cVector_Minus;
   this.Subtract    = cVector_Minus;
   this.Difference  = cVector_Minus;
}
// -------------------------------------------------------------------------
function cVector_Dot(VecB)
{
   var wDotProd;
   if (this.XElt.length != VecB.XElt.length)
      alert ("Incompatible vector lengths for dot product");
   else
   {
      wDotProd = 0;
      for( var ix = 0; ix < this.XElt.length; ix++)
         wDotProd += this.XElt[ix]*VecB.XElt[ix];
   }
   return wDotProd;
}
// -------------------------------------------------------------------------
function cVector_ScalarMult(iScalar)
{
   var wVec = new cVector("0");
   for( var ix = 0; ix < this.XElt.length; ix++)
      wVec.XElt[ix] = this.XElt[ix] * iScalar;
   return wVec;
}
// -------------------------------------------------------------------------
function cVector_Plus(VecB)
{
   var wVec = new cVector("0");
   if (this.XElt.length != VecB.XElt.length)
      alert ("Incompatible vector lengths for addition");
   else
      for( var ix = 0; ix < this.XElt.length; ix++)
         wVec.XElt[ix] = (1 * this.XElt[ix]) + (1 * VecB.XElt[ix]);
   return wVec;
}
// -------------------------------------------------------------------------
function cVector_Minus(VecB)
{
   var wVec = new cVector("0");
   if (this.XElt.length != VecB.XElt.length)
      alert ("Incompatible vector lengths for subtraction");
   else
      for( var ix = 0; ix < this.XElt.length; ix++)
         wVec.XElt[ix] = this.XElt[ix] - VecB.XElt[ix];
   return wVec;
}
// -------------------------------------------------------------------------
function cVector_Cross(VecB)
{
   var wVec = new cVector("0");
   if (this.XElt.length < 3 || VecB.XElt.length < 3 )
      alert ("Incompatible vector lengths for vector multiplication");
   else
   {
      wVec.XElt[0] = (this.XElt[1] * VecB.XElt[2]) - (this.XElt[2] * VecB.XElt[1]);
      wVec.XElt[1] = (this.XElt[2] * VecB.XElt[0]) - (this.XElt[0] * VecB.XElt[2]);
      wVec.XElt[2] = (this.XElt[0] * VecB.XElt[1]) - (this.XElt[1] * VecB.XElt[0]);
   }
   return wVec;
}
// -------------------------------------------------------------------------
function cVector_Norm()
{
   return Math.sqrt(this.Dot(this));
}
// -------------------------------------------------------------------------
function cVector_Angle(VecB)
{
   return Math.acos( this.Dot(VecB) / (this.Norm() * VecB.Norm()));
}
// -------------------------------------------------------------------------
function cVector_McPrint()
{
   wTxt = "(" ;
   for (rowIx = 0; rowIx < this.XElt.length; rowIx++)
   {
      if (rowIx > 0)
         wTxt += ",";
      wTxt += WMATPAD + formatDec(this.XElt[rowIx],cMatrix_Precision) + WMATPAD;
   }
   wTxt += ")";
   return wTxt;
}
// -------------------------------------------------------------------------
// Function to format number to show n decimal places
// -------------------------------------------------------------------------
function formatDec (iNum,wDP)
{
   if (wDP == undefined)
      wDP = 2;
   if (wDP < 0)
      wDP = 0;
   var wNeg = false;
   if (iNum < 0)
   {
      iNum *= -1;
      wNeg = true;
   }
   var wNum;
   var sNum;
   var strZeros = "00000000000000000000";
   if (wDP > 20)
      wDP = 20;
   wNum = (1.0 * iNum) + (0.5 * Math.pow(10,-1 * wDP));
   sNum = new String(wNum.toString());
   var ix  = sNum.indexOf("e-");
   if (ix  > -1)
   {
     var wExp = Number(sNum.substr (ix+2));
     tString = new String("0.0000000000000000000000000000000");
     sNum = tString.substr(0,wExp+1) +
        sNum.substr(0,1) + sNum.substr(2,ix-2);
   }
   ix = sNum.indexOf(".");
   if (ix < 0)
      sNum = sNum + "." + strZeros;
   else
      sNum = sNum + strZeros;
   ix = sNum.indexOf(".");
   if (wDP > 0)
      sNum = sNum.substr(0,ix + wDP + 1);
   else
      sNum = sNum.substr(0,ix);
   if (wNeg == true && sNum != 0)
     sNum = "-" + sNum;

   return sNum;
}

